#line 1 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/HTTP_Demo_Internal.c"
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/__netethinternal.h"
#line 6 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/__netethinternal.h"
typedef struct {
 unsigned char valid;
 unsigned long tmr;
 unsigned char ip[4];
 unsigned char mac[6];
} Net_Ethernet_Intern_arpCacheStruct;

extern Net_Ethernet_Intern_arpCacheStruct Net_Ethernet_Intern_arpCache[];


extern unsigned char Net_Ethernet_Intern_macAddr[6];
extern unsigned char Net_Ethernet_Intern_ipAddr[4];
extern unsigned char Net_Ethernet_Intern_gwIpAddr[4];
extern unsigned char Net_Ethernet_Intern_ipMask[4];
extern unsigned char Net_Ethernet_Intern_dnsIpAddr[4];
extern unsigned char Net_Ethernet_Intern_rmtIpAddr[4];

extern unsigned long Net_Ethernet_Intern_userTimerSec;



typedef struct {
 char remoteIP[4];
 char remoteMAC[6];
 unsigned int remotePort;
 unsigned int destPort;
 unsigned int dataLength;
 unsigned int broadcastMark;
} UDP_Intern_Dsc;


extern UDP_Intern_Dsc udpRecord_Intern;




typedef struct {
 char remoteIP[4];
 char remoteMAC[6];
 unsigned int remotePort;
 unsigned int destPort;

 unsigned int dataLength;
 unsigned int remoteMSS;
 unsigned int myWin;
 unsigned int myMSS;
 unsigned long mySeq;
 unsigned long myACK;

 char stateTimer;
 char retransmitTimer;
 unsigned int packetID;
 char open;
 char ID;
 char broadcastMark;
 char state;










 unsigned int nextSend;
 unsigned int lastACK;
 unsigned int lastSent;
 unsigned int lastWritten;
 unsigned int numToSend;
 char buffState;
 char *txBuffer;


} SOCKET_Intern_Dsc;



extern const char NUM_OF_SOCKET_Intern;
extern const unsigned int TCP_TX_SIZE_Intern;
extern const unsigned int MY_MSS_Intern;
extern const unsigned int SYN_FIN_WAIT_Intern;
extern const unsigned int RETRANSMIT_WAIT_Intern;

extern char tx_buffers_Intern[][];
extern SOCKET_Intern_Dsc socket_Intern[];
#line 97 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/__netethinternal.h"
extern void Net_Ethernet_Intern_Init(unsigned char *mac, unsigned char *ip, unsigned long configuration);
extern unsigned char Net_Ethernet_Intern_doPacket();
extern void Net_Ethernet_Intern_putByte(unsigned char b);
extern void Net_Ethernet_Intern_putBytes(unsigned char *ptr, unsigned int n);
extern void Net_Ethernet_Intern_putConstBytes(const unsigned char *ptr, unsigned int n);
extern unsigned char Net_Ethernet_Intern_getByte();
extern void Net_Ethernet_Intern_getBytes(unsigned char *ptr, unsigned long addr, unsigned int n);
extern unsigned int Net_Ethernet_Intern_UserUDP(UDP_Intern_Dsc *udpDsc);
extern void Net_Ethernet_Intern_payloadInitUDP();
extern void Net_Ethernet_Intern_UserTCP(SOCKET_Intern_Dsc *socket);
extern void Net_Ethernet_Intern_confNetwork(char *ipMask, char *gwIpAddr, char *dnsIpAddr);

extern char Net_Ethernet_Intern_connectTCP(char *remoteIP, unsigned int remote_port ,unsigned int my_port, SOCKET_Intern_Dsc **used_socket);
extern char Net_Ethernet_Intern_disconnectTCP(SOCKET_Intern_Dsc *socket);

extern char Net_Ethernet_Intern_putByteTCP(char ch, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putBytesTCP(char *ptr,unsigned int n, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putConstBytesTCP(const char *ptr,unsigned int n, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putStringTCP(char *ptr, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putConstStringTCP(const char *ptr, SOCKET_Intern_Dsc *socket);
extern char Net_Ethernet_Intern_bufferEmptyTCP(SOCKET_Intern_Dsc *socket);
extern void Net_Ethernet_Intern_stackInitTCP();
extern char Net_Ethernet_Intern_startSendTCP(SOCKET_Intern_Dsc *socket);
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/uart1.h"
#line 18 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/uart1.h"
typedef void (*tPointerFcn)(void);
typedef char *pnt;


 typedef struct rx_q_struct
 {
 int RxIn;
 int RxOut;
 char RxQueue[ 64 ];
 } rx_q_struct;


typedef struct tx_q_struct
{
 int TxIn;
 int TxOut;
 pnt TxQueue[ 32 ];
} tx_q_struct;




void UART1_SetBaud(void);
void UART1_StartRx(void);
void UART1_StartTx(void);

void InitUART1(void);
void UART1_TxQueueInit(void);
void UART1_RxQueueInit(void);

void UART1_SendMsg(char *s);
void UART1_CheckQueue(void);
void UART1_PutQueue(char *msg);
char UART1_GetChar(char *rxbyte);


void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/buffers.h"
#line 13 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/buffers.h"
char* GetBuffer(void);
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/coretimer.h"
#line 13 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/coretimer.h"
void InitCoreTimer(void);
void TimerCheck();
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/ethernet.h"
#line 9 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/ethernet.h"
void InitPHYPins();
void InitEthernet();
void DoEthernet();










typedef char *pntr;


typedef struct TCPC_FIFO_struct
{
 int TCPC_FIFO_In;
 int TCPC_FIFO_Out;
 pntr TCPC_FIFO[ 32 ];
} TCPC_FIFO_struct;


void InitTCP_Client();
void DoTCP_Client();
void Put_FIFO1(char *msg);




struct SNTPFrame
{
 unsigned long int Flags;
 unsigned long int RootDelay;
 unsigned long int RootDispersion;
 unsigned long int ReferenceID;
 unsigned long int RefTS1;
 unsigned long int RefTS2;
 unsigned long int OriginTS1;
 unsigned long int OriginTS2;
 unsigned long int ReceiveTS1;
 unsigned long int ReceiveTS2;
 unsigned long int TransmitTS1;
 unsigned long int TransmitTS2;
};
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
#line 26 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
struct timers
{
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 44 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
void init_timerpool(void);
#line 59 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
unsigned short int get_timer(void);
#line 73 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
void free_timer(unsigned short int nbr);
#line 88 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 102 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 116 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/timers.h"
void irqhandler_timer(void);
#line 33 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/HTTP_Demo_Internal.c"
extern char Got_dhcp;



void main() {
 AD1PCFG |= 0xFFFF;


 LATD9_bit = 1;
 TRISD9_bit = 0;

 LATD2_bit = 0;
 TRISD2_bit = 0;

 InitCoreTimer();
 init_timerpool();
 InitUART1();

 EnableInterrupts();

 UART1_PutQueue("Started Ethernet Test\r\n");


 InitEthernet();
 InitTCP_Client();



 while (1) {
 DoEthernet();
 if ((Got_dhcp) && Net_Ethernet_Intern_doDHCPLeaseTime())
 Net_Ethernet_Intern_renewDHCP(5);

 TimerCheck();
 UART1_CheckQueue();
 UART1_Rx();
 DoTCP_Client();
 }
}
