#line 1 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/uart1.h"
#line 18 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/uart1.h"
typedef void (*tPointerFcn)(void);
typedef char *pnt;


 typedef struct rx_q_struct
 {
 int RxIn;
 int RxOut;
 char RxQueue[ 64 ];
 } rx_q_struct;


typedef struct tx_q_struct
{
 int TxIn;
 int TxOut;
 pnt TxQueue[ 32 ];
} tx_q_struct;




void UART1_SetBaud(void);
void UART1_StartRx(void);
void UART1_StartTx(void);

void InitUART1(void);
void UART1_TxQueueInit(void);
void UART1_RxQueueInit(void);

void UART1_SendMsg(char *s);
void UART1_CheckQueue(void);
void UART1_PutQueue(char *msg);
char UART1_GetChar(char *rxbyte);


void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/buffers.h"
#line 13 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/buffers.h"
char* GetBuffer(void);
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/ethernet.h"
#line 9 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/ethernet.h"
void InitPHYPins();
void InitEthernet();
void DoEthernet();










typedef char *pntr;


typedef struct TCPC_FIFO_struct
{
 int TCPC_FIFO_In;
 int TCPC_FIFO_Out;
 pntr TCPC_FIFO[ 32 ];
} TCPC_FIFO_struct;


void InitTCP_Client();
void DoTCP_Client();
void Put_FIFO1(char *msg);




struct SNTPFrame
{
 unsigned long int Flags;
 unsigned long int RootDelay;
 unsigned long int RootDispersion;
 unsigned long int ReferenceID;
 unsigned long int RefTS1;
 unsigned long int RefTS2;
 unsigned long int OriginTS1;
 unsigned long int OriginTS2;
 unsigned long int ReceiveTS1;
 unsigned long int ReceiveTS2;
 unsigned long int TransmitTS1;
 unsigned long int TransmitTS2;
};
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/coretimer.h"
#line 13 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/coretimer.h"
void InitCoreTimer(void);
void TimerCheck();
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/__time.h"
#line 27 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/__time.h"
typedef struct {
 unsigned char ss;
 unsigned char mn;
 unsigned char hh;
 unsigned char md;
 unsigned char wd;
 unsigned char mo;
 unsigned int yy;
} TimeStruct ;
#line 40 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/__time.h"
extern long Time_jd1970 ;
#line 45 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/__time.h"
long Time_dateToEpoch(TimeStruct *ts);
long Time_dateDiff(TimeStruct *t1, TimeStruct *t2);
void Time_epochToDate(long e, TimeStruct *ts);
#line 14 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
char RcvBuf[ 64 ];
char RcvBufPtr;

char *XmtBuf;
char XmtBufPtr;

rx_q_struct RxQ;
tx_q_struct TxQ;


tPointerFcn UART1_RxFuncPtr = UART1_Rx1;

extern unsigned char myMacAddr[6];
extern unsigned char myIpAddr[4];

char Msg1[] = "How now brown cow?\r\n";
char Msg2[] = "155,12/10/15 00:00:00,0004A3203BA4,0004,0014,0000,0003,000E,0009,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000\r\n";
extern unsigned int TCPC_ClientState;
extern TimeStruct ts1;
extern long Epoch;
extern unsigned long int msec;
#line 41 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Interrupt() iv IVT_UART_1 ilevel 7 ics ICS_AUTO {
 char R_data;
 char T_data;

 if (URXDA_bit){
 R_data = U1RXREG;

 RxQ.RxQueue[RxQ.RxIn++] = R_data;
 if (RxQ.RxIn > ( 64 -1))
 RxQ.RxIn = 0;
 U1RXIF_bit = 0;

 }else{
 T_data = XmtBuf[XmtBufPtr++];
 if (T_data ==  0x00 ){
 U1TXIE_bit = 0;
 }else{
 U1TXREG = T_data;
 U1TXIF_bit = 0;
 }
 }
}
#line 66 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_SetBaud(void){

 U1BRG = 520;
}
#line 73 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_StartRx(void){
 ON__U1MODE_bit = 1;
 URXEN_bit = 1;

 U1IP0_bit = 0;
 U1IP1_bit = 1;
 U1IP2_bit = 1;
 U1IS1_bit = 1;
 U1IS0_bit = 1;

 URXISEL0_bit = 0;
 URXISEL1_bit = 0;

 U1RXIF_bit = 0;
 U1RXIE_bit = 1;
}
#line 92 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_StartTx(void){
 UTXEN_bit = 1;

 UTXISEL0_bit = 0;
 UTXISEL1_bit = 1;

 U1TXIF_bit = 0;
 U1TXIE_bit = 1;
}
#line 109 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void InitUART1(void){
 UART1_SetBaud();
 UART1_RxQueueInit();
 UART1_TxQueueInit();
 UART1_StartRx();
}
#line 118 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_TxQueueInit(void){
 TxQ.TxIn = 0;
 TxQ.TxOut = 0;
 XmtBufPtr = 0;
}
#line 126 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_RxQueueInit(void){
 RxQ.RxIn = 0;
 RxQ.RxOut = 0;
 RcvBufPtr = 0;
}
#line 134 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_SendMsg(char *s){
 XmtBuf = s;
 XmtBufPtr = 0;
 UART1_StartTx();
}
#line 145 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_CheckQueue(void){


 if ((!U1TXIE_bit)&&(TRMT_bit)){

 if (TxQ.TxIn != TxQ.TxOut){
 UART1_SendMsg(TxQ.TxQueue[TxQ.TxOut++]);
 if (TxQ.TxOut > ( 32 -1))
 TxQ.TxOut = 0;
 }
 }
}
#line 161 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_PutQueue(char *msg){
 TxQ.TxQueue[TxQ.TxIn++] = msg;
 if (TxQ.TxIn > ( 32 -1))
 TxQ.TxIn = 0;
}
#line 171 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
char UART1_GetChar(char *rxbyte){
 if (RxQ.RxIn != RxQ.RxOut){
 *rxbyte = RxQ.RxQueue[RxQ.RxOut++];
 if (RxQ.RxOut > ( 64 -1))
 RxQ.RxOut = 0;
 return 1;
 }else{
 return 0;
 }
}
#line 184 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Rx(void){
 UART1_RxFuncPtr();
}
#line 191 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Rx1(void){
 char rxchar;

 if (UART1_GetChar(&rxchar)){
 switch (rxchar){
 case  0x00 :
 break;

 case '\r':
 break;

 case '\n':
 RcvBuf[RcvBufPtr++] = rxchar;
 RcvBuf[RcvBufPtr] = 0;
 RcvBufPtr = 0;
 UART1_RxFuncPtr = UART1_Rx2;
 break;

 default:
 if (RcvBufPtr < ( 64 -2))
 RcvBuf[RcvBufPtr++] = rxchar;
 break;
 }
 }
}
#line 219 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Rx2(void){
 char *BufNum;
 int i;
 unsigned int My[6];
 char String[8];
 int Year, Month, Day, DoW, Hour, Minute, Second;

 long Fraction;

 switch (RcvBuf[0]){



 case 'a':
 Year = ts1.yy;
 Month = ts1.mo;
 Day = ts1.md;
 Hour = ts1.hh;
 Minute = ts1.mn;
 Second = ts1.ss;

 BufNum = GetBuffer();
 sprintf(BufNum,"%04d/%02d/%02d %02d:%02d:%02d\r\n",Year,Month,Day,Hour,Minute,Second);
 UART1_PutQueue(BufNum);
 break;

 case 'b':



 RcvBuf[23] = 0;
 UART1_PutQueue(RcvBuf);


 if (strlen(RcvBuf) == 23) {
 UART1_PutQueue("Setting clock/calendar \r\n");
 String[2] = 0;

 String[0] = RcvBuf[2];
 String[1] = RcvBuf[3];
 ts1.yy = 2000 + atoi(String);

 String[0] = RcvBuf[5];
 String[1] = RcvBuf[6];
 ts1.mo = atoi(String);

 String[0] = RcvBuf[8];
 String[1] = RcvBuf[9];
 ts1.md = atoi(String);

 String[0] = RcvBuf[11];
 String[1] = RcvBuf[12];
 Dow = atoi(String);
 switch (DoW) {
 case 1: ts1.wd = 6; break;
 case 2: ts1.wd = 0; break;
 case 3: ts1.wd = 1; break;
 case 4: ts1.wd = 2; break;
 case 5: ts1.wd = 3; break;
 case 6: ts1.wd = 4; break;
 case 7: ts1.wd = 5; break;
 }

 String[0] = RcvBuf[14];
 String[1] = RcvBuf[15];
 ts1.hh = atoi(String);

 String[0] = RcvBuf[17];
 String[1] = RcvBuf[18];
 ts1.mn = atoi(String);

 String[0] = RcvBuf[20];
 String[1] = RcvBuf[21];
 ts1.ss = atoi(String);

 Epoch = Time_dateToEpoch(&ts1);
 }
 else {
 BufNum = GetBuffer();
 sprintf(BufNum,"Incorrect length: %d \r\n",strlen(RcvBuf));
 UART1_PutQueue(BufNum);
 }
 break;



 case 'c':
 Put_FIFO1(Msg2);
 break;

 case 'd':
 BufNum = GetBuffer();
 sprintf(BufNum,"%d\r\n",TCPC_ClientState);
 UART1_PutQueue(BufNum);
 break;

 case 'e':
 InitEthernet();
 UART1_PutQueue("ACK\r\n");
 break;

 case 'f':
 BufNum = GetBuffer();
 sprintf(BufNum,"%d\r\n",TxQ.TxIn);
 UART1_PutQueue(BufNum);
 break;

 case 'g':

 for (i=0;i<6;i++)
 My[i] = myMacAddr[i];
 BufNum = GetBuffer();
 sprintf(BufNum,"%02X:%02X:%02X:%02X:%02X:%02X\r\n",
 My[0],My[1],My[2],My[3],My[4],My[5],My[6]);
 UART1_PutQueue(BufNum);
 break;

 case 'h':

 for (i=0;i<4;i++)
 My[i] = myIpAddr[i];
 BufNum = GetBuffer();
 sprintf(BufNum,"%d.%d.%d.%d\r\n",My[0],My[1],My[2],My[3]);
 UART1_PutQueue(BufNum);
 break;

 case 'i':
 Fraction = (msec * 4294967296) / 1000;
 BufNum = GetBuffer();
 sprintf(BufNum,"%LX\r\n",Fraction);
 UART1_PutQueue(BufNum);
 break;









 default:
 UART1_PutQueue("Unknown command: ");

 BufNum = GetBuffer();
 (void)sprintf(BufNum,"%c\r\n",RcvBuf[0]);
 UART1_PutQueue(BufNum);
 break;
 }
 UART1_RxFuncPtr = UART1_Rx1;
}
