#line 1 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/__Lib_NetEthInternal_Defs.c"
#line 1 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/__netethinternal.h"
#line 6 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/__netethinternal.h"
typedef struct {
 unsigned char valid;
 unsigned long tmr;
 unsigned char ip[4];
 unsigned char mac[6];
} Net_Ethernet_Intern_arpCacheStruct;

extern Net_Ethernet_Intern_arpCacheStruct Net_Ethernet_Intern_arpCache[];


extern unsigned char Net_Ethernet_Intern_macAddr[6];
extern unsigned char Net_Ethernet_Intern_ipAddr[4];
extern unsigned char Net_Ethernet_Intern_gwIpAddr[4];
extern unsigned char Net_Ethernet_Intern_ipMask[4];
extern unsigned char Net_Ethernet_Intern_dnsIpAddr[4];
extern unsigned char Net_Ethernet_Intern_rmtIpAddr[4];

extern unsigned long Net_Ethernet_Intern_userTimerSec;



typedef struct {
 char remoteIP[4];
 char remoteMAC[6];
 unsigned int remotePort;
 unsigned int destPort;
 unsigned int dataLength;
 unsigned int broadcastMark;
} UDP_Intern_Dsc;


extern UDP_Intern_Dsc udpRecord_Intern;




typedef struct {
 char remoteIP[4];
 char remoteMAC[6];
 unsigned int remotePort;
 unsigned int destPort;

 unsigned int dataLength;
 unsigned int remoteMSS;
 unsigned int myWin;
 unsigned int myMSS;
 unsigned long mySeq;
 unsigned long myACK;

 char stateTimer;
 char retransmitTimer;
 unsigned int packetID;
 char open;
 char ID;
 char broadcastMark;
 char state;










 unsigned int nextSend;
 unsigned int lastACK;
 unsigned int lastSent;
 unsigned int lastWritten;
 unsigned int numToSend;
 char buffState;
 char *txBuffer;


} SOCKET_Intern_Dsc;



extern const char NUM_OF_SOCKET_Intern;
extern const unsigned int TCP_TX_SIZE_Intern;
extern const unsigned int MY_MSS_Intern;
extern const unsigned int SYN_FIN_WAIT_Intern;
extern const unsigned int RETRANSMIT_WAIT_Intern;

extern char tx_buffers_Intern[][];
extern SOCKET_Intern_Dsc socket_Intern[];
#line 97 "c:/users/public/projects/pic/projects/ethernettest/ethernet_test_code/mikroc pro for pic32/__netethinternal.h"
extern void Net_Ethernet_Intern_Init(unsigned char *mac, unsigned char *ip, unsigned long configuration);
extern unsigned char Net_Ethernet_Intern_doPacket();
extern void Net_Ethernet_Intern_putByte(unsigned char b);
extern void Net_Ethernet_Intern_putBytes(unsigned char *ptr, unsigned int n);
extern void Net_Ethernet_Intern_putConstBytes(const unsigned char *ptr, unsigned int n);
extern unsigned char Net_Ethernet_Intern_getByte();
extern void Net_Ethernet_Intern_getBytes(unsigned char *ptr, unsigned long addr, unsigned int n);
extern unsigned int Net_Ethernet_Intern_UserUDP(UDP_Intern_Dsc *udpDsc);
extern void Net_Ethernet_Intern_payloadInitUDP();
extern void Net_Ethernet_Intern_UserTCP(SOCKET_Intern_Dsc *socket);
extern void Net_Ethernet_Intern_confNetwork(char *ipMask, char *gwIpAddr, char *dnsIpAddr);

extern char Net_Ethernet_Intern_connectTCP(char *remoteIP, unsigned int remote_port ,unsigned int my_port, SOCKET_Intern_Dsc **used_socket);
extern char Net_Ethernet_Intern_disconnectTCP(SOCKET_Intern_Dsc *socket);

extern char Net_Ethernet_Intern_putByteTCP(char ch, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putBytesTCP(char *ptr,unsigned int n, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putConstBytesTCP(const char *ptr,unsigned int n, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putStringTCP(char *ptr, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putConstStringTCP(const char *ptr, SOCKET_Intern_Dsc *socket);
extern char Net_Ethernet_Intern_bufferEmptyTCP(SOCKET_Intern_Dsc *socket);
extern void Net_Ethernet_Intern_stackInitTCP();
extern char Net_Ethernet_Intern_startSendTCP(SOCKET_Intern_Dsc *socket);
#line 3 "C:/Users/Public/Projects/PIC/Projects/EthernetTest/Ethernet_Test_Code/mikroC PRO for PIC32/__Lib_NetEthInternal_Defs.c"
const char ARPCACHESIZE_Intern = 3;
Net_Ethernet_Intern_arpCacheStruct Net_Ethernet_Intern_arpCache[ARPCACHESIZE_Intern];

const char NUM_OF_SOCKET_Intern = 7;
const unsigned int TCP_TX_SIZE_Intern = 1024;

const unsigned int MY_MSS_Intern = 512;

const unsigned int SYN_FIN_WAIT_Intern = 1;
const unsigned int RETRANSMIT_WAIT_Intern = 1;

char tx_buffers_Intern[NUM_OF_SOCKET_Intern][TCP_TX_SIZE_Intern];

UDP_Intern_Dsc udpRecord_Intern;

SOCKET_Intern_Dsc socket_Intern[NUM_OF_SOCKET_Intern];
