_InitPHYPins:
;Ethernet.c,93 :: 		void InitPHYPins(){
;Ethernet.c,94 :: 		TRISD11_bit = 0;   // ETH_ALT_MDC_BIT
LUI	R2, BitMask(TRISD11_bit+0)
ORI	R2, R2, BitMask(TRISD11_bit+0)
_SX	8, Offset(TRISD11_bit+4), 4
;Ethernet.c,95 :: 		TRISD8_bit = 1;    // ETH_ALT_MDIO_BIT
LUI	R2, BitMask(TRISD8_bit+0)
ORI	R2, R2, BitMask(TRISD8_bit+0)
_SX	8, Offset(TRISD8_bit+8), 4
;Ethernet.c,97 :: 		TRISA15_bit = 0;   // ETH_ALT_TXEN_BIT
LUI	R2, BitMask(TRISA15_bit+0)
ORI	R2, R2, BitMask(TRISA15_bit+0)
_SX	8, Offset(TRISA15_bit+4), 4
;Ethernet.c,98 :: 		TRISD14_bit = 0;   // ETH_ALT_TXD0_BIT
LUI	R2, BitMask(TRISD14_bit+0)
ORI	R2, R2, BitMask(TRISD14_bit+0)
_SX	8, Offset(TRISD14_bit+4), 4
;Ethernet.c,99 :: 		TRISD15_bit = 0;   // ETH_ALT_TXD1_BIT
LUI	R2, BitMask(TRISD15_bit+0)
ORI	R2, R2, BitMask(TRISD15_bit+0)
_SX	8, Offset(TRISD15_bit+4), 4
;Ethernet.c,101 :: 		TRISG9_bit = 1;    // ETH_ALT_RXCLK_BIT
LUI	R2, BitMask(TRISG9_bit+0)
ORI	R2, R2, BitMask(TRISG9_bit+0)
_SX	8, Offset(TRISG9_bit+8), 4
;Ethernet.c,102 :: 		TRISG8_bit = 1;    // ETH_ALT_RXDV_BIT
LUI	R2, BitMask(TRISG8_bit+0)
ORI	R2, R2, BitMask(TRISG8_bit+0)
_SX	8, Offset(TRISG8_bit+8), 4
;Ethernet.c,103 :: 		TRISE8_bit = 1;    // ETH_ALT_RXD0_BIT
LUI	R2, BitMask(TRISE8_bit+0)
ORI	R2, R2, BitMask(TRISE8_bit+0)
_SX	8, Offset(TRISE8_bit+8), 4
;Ethernet.c,104 :: 		TRISE9_bit = 1;    // ETH_ALT_RXD1_BIT
LUI	R2, BitMask(TRISE9_bit+0)
ORI	R2, R2, BitMask(TRISE9_bit+0)
_SX	8, Offset(TRISE9_bit+8), 4
;Ethernet.c,105 :: 		TRISG15_bit = 1;   // ETH_ALT_RXERR_BIT
LUI	R2, BitMask(TRISG15_bit+0)
ORI	R2, R2, BitMask(TRISG15_bit+0)
_SX	8, Offset(TRISG15_bit+8), 4
;Ethernet.c,106 :: 		}
L_end_InitPHYPins:
JR	RA
NOP	
; end of _InitPHYPins
_InitEthernet:
;Ethernet.c,109 :: 		void InitEthernet() {
ADDIU	SP, SP, -28
SW	RA, 0(SP)
;Ethernet.c,114 :: 		InitPHYPins();  // Initialize physical pins
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
JAL	_InitPHYPins+0
NOP	
;Ethernet.c,116 :: 		Net_Ethernet_Intern_stackInitTCP();
JAL	_Net_Ethernet_Intern_stackInitTCP+0
NOP	
;Ethernet.c,119 :: 		Net_Ethernet_Intern_Init(myMacAddr, myIpAddr, Net_Eth_Int_AUTO_NEGOTIATION & Net_Eth_Int_DEFAULT_MAC );
ORI	R27, R0, 65531
LUI	R26, #hi_addr(_myIpAddr+0)
ORI	R26, R26, #lo_addr(_myIpAddr+0)
LUI	R25, #hi_addr(_myMacAddr+0)
ORI	R25, R25, #lo_addr(_myMacAddr+0)
JAL	_Net_Ethernet_Intern_Init+0
NOP	
;Ethernet.c,121 :: 		if (Use_dhcp) {  // These functions are blocking!!!
LBU	R2, Offset(_Use_dhcp+0)(GP)
BNE	R2, R0, L__InitEthernet165
NOP	
J	L_InitEthernet0
NOP	
L__InitEthernet165:
;Ethernet.c,122 :: 		if (Net_Ethernet_Intern_initDHCP(5)) { // Get network configuration from DHCP server, wait 5 sec for the response
ORI	R25, R0, 5
JAL	_Net_Ethernet_Intern_initDHCP+0
NOP	
BNE	R2, R0, L__InitEthernet167
NOP	
J	L_InitEthernet1
NOP	
L__InitEthernet167:
;Ethernet.c,123 :: 		memcpy(myIpAddr,Net_Ethernet_Intern_getIpAddress(), 4); // Fetch IP address
JAL	_Net_Ethernet_Intern_getIpAddress+0
NOP	
ORI	R27, R0, 4
MOVZ	R26, R2, R0
LUI	R25, #hi_addr(_myIpAddr+0)
ORI	R25, R25, #lo_addr(_myIpAddr+0)
JAL	_memcpy+0
NOP	
;Ethernet.c,124 :: 		memcpy(gwIpAddr, Net_Ethernet_Intern_getGwIpAddress(), 4); // Fetch gateway IP address
JAL	_Net_Ethernet_Intern_getGwIpAddress+0
NOP	
ORI	R27, R0, 4
MOVZ	R26, R2, R0
LUI	R25, #hi_addr(_gwIpAddr+0)
ORI	R25, R25, #lo_addr(_gwIpAddr+0)
JAL	_memcpy+0
NOP	
;Ethernet.c,125 :: 		memcpy(dnsIpAddr, Net_Ethernet_Intern_getDnsIpAddress(), 4); // Fetch DNS server address
JAL	_Net_Ethernet_Intern_getDnsIpAddress+0
NOP	
ORI	R27, R0, 4
MOVZ	R26, R2, R0
LUI	R25, #hi_addr(_dnsIpAddr+0)
ORI	R25, R25, #lo_addr(_dnsIpAddr+0)
JAL	_memcpy+0
NOP	
;Ethernet.c,126 :: 		memcpy(IpMask, Net_Ethernet_Intern_getIpMask(), 4); // Fetch IP subnet mask
JAL	_Net_Ethernet_Intern_getIpMask+0
NOP	
ORI	R27, R0, 4
MOVZ	R26, R2, R0
LUI	R25, #hi_addr(_ipMask+0)
ORI	R25, R25, #lo_addr(_ipMask+0)
JAL	_memcpy+0
NOP	
;Ethernet.c,127 :: 		Got_dhcp = TRUE;
ORI	R2, R0, 1
SB	R2, Offset(_Got_dhcp+0)(GP)
;Ethernet.c,129 :: 		Net_Ethernet_Intern_confNetwork(ipMask, gwIpAddr, dnsIpAddr);
LUI	R27, #hi_addr(_dnsIpAddr+0)
ORI	R27, R27, #lo_addr(_dnsIpAddr+0)
LUI	R26, #hi_addr(_gwIpAddr+0)
ORI	R26, R26, #lo_addr(_gwIpAddr+0)
LUI	R25, #hi_addr(_ipMask+0)
ORI	R25, R25, #lo_addr(_ipMask+0)
JAL	_Net_Ethernet_Intern_confNetwork+0
NOP	
;Ethernet.c,130 :: 		} else {
J	L_InitEthernet2
NOP	
L_InitEthernet1:
;Ethernet.c,131 :: 		UART1_putQueue("DHCP not responding\r\n");
LUI	R25, #hi_addr(?lstr1_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr1_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,132 :: 		Got_dhcp = FALSE;
SB	R0, Offset(_Got_dhcp+0)(GP)
;Ethernet.c,133 :: 		}
L_InitEthernet2:
;Ethernet.c,134 :: 		}
L_InitEthernet0:
;Ethernet.c,135 :: 		Net_Ethernet_Intern_confNetwork(ipMask, gwIpAddr, dnsIpAddr);
LUI	R27, #hi_addr(_dnsIpAddr+0)
ORI	R27, R27, #lo_addr(_dnsIpAddr+0)
LUI	R26, #hi_addr(_gwIpAddr+0)
ORI	R26, R26, #lo_addr(_gwIpAddr+0)
LUI	R25, #hi_addr(_ipMask+0)
ORI	R25, R25, #lo_addr(_ipMask+0)
JAL	_Net_Ethernet_Intern_confNetwork+0
NOP	
;Ethernet.c,136 :: 		Delay_ms(1000);
LUI	R24, 406
ORI	R24, R24, 59050
L_InitEthernet3:
ADDIU	R24, R24, -1
BNE	R24, R0, L_InitEthernet3
NOP	
;Ethernet.c,138 :: 		for (i = 0; i < NUM_OF_SOCKET_Intern; i++)
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_InitEthernet5:
; i start address is: 16 (R4)
SEH	R2, R4
SLTI	R2, R2, _NUM_OF_SOCKET_Intern
BNE	R2, R0, L__InitEthernet168
NOP	
J	L_InitEthernet6
NOP	
L__InitEthernet168:
;Ethernet.c,139 :: 		pos[i] = 0;
SEH	R2, R4
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
SH	R0, 0(R2)
;Ethernet.c,138 :: 		for (i = 0; i < NUM_OF_SOCKET_Intern; i++)
ADDIU	R2, R4, 1
SEH	R4, R2
;Ethernet.c,139 :: 		pos[i] = 0;
; i end address is: 16 (R4)
J	L_InitEthernet5
NOP	
L_InitEthernet6:
;Ethernet.c,141 :: 		for (i=0;i<4;i++)
; i start address is: 20 (R5)
MOVZ	R5, R0, R0
; i end address is: 20 (R5)
L_InitEthernet8:
; i start address is: 20 (R5)
SEH	R2, R5
SLTI	R2, R2, 4
BNE	R2, R0, L__InitEthernet169
NOP	
J	L_InitEthernet9
NOP	
L__InitEthernet169:
;Ethernet.c,142 :: 		My[i] = myIpAddr[i];
ADDIU	R3, SP, 16
SEH	R2, R5
SLL	R2, R2, 1
ADDU	R4, R3, R2
SEH	R3, R5
LUI	R2, #hi_addr(_myIpAddr+0)
ORI	R2, R2, #lo_addr(_myIpAddr+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SH	R2, 0(R4)
;Ethernet.c,141 :: 		for (i=0;i<4;i++)
ADDIU	R2, R5, 1
SEH	R5, R2
;Ethernet.c,142 :: 		My[i] = myIpAddr[i];
; i end address is: 20 (R5)
J	L_InitEthernet8
NOP	
L_InitEthernet9:
;Ethernet.c,143 :: 		BufNum = GetBuffer();
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,144 :: 		sprintf(BufNum,"My IP: %d.%d.%d.%d\r\n",My[0],My[1],My[2],My[3]);
ADDIU	R4, SP, 16
ADDIU	R3, R4, 6
LHU	R7, 0(R3)
ADDIU	R3, R4, 4
LHU	R6, 0(R3)
ADDIU	R3, R4, 2
LHU	R5, 0(R3)
LHU	R4, 0(R4)
LUI	R3, #hi_addr(?lstr_2_Ethernet+0)
ORI	R3, R3, #lo_addr(?lstr_2_Ethernet+0)
ADDIU	SP, SP, -24
SH	R7, 20(SP)
SH	R6, 16(SP)
SH	R5, 12(SP)
SH	R4, 8(SP)
SW	R3, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 24
;Ethernet.c,145 :: 		UART1_PutQueue(BufNum);
MOVZ	R25, R20, R0
; BufNum end address is: 80 (R20)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,146 :: 		}
L_end_InitEthernet:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 28
JR	RA
NOP	
; end of _InitEthernet
_DoEthernet:
;Ethernet.c,149 :: 		void DoEthernet() {
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;Ethernet.c,153 :: 		Rtn = Net_Ethernet_Intern_doPacket();
JAL	_Net_Ethernet_Intern_doPacket+0
NOP	
;Ethernet.c,176 :: 		for (i = 0; i < NUM_OF_SOCKET_Intern; i++) {
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_DoEthernet11:
; i start address is: 16 (R4)
SEH	R2, R4
SLTI	R2, R2, _NUM_OF_SOCKET_Intern
BNE	R2, R0, L__DoEthernet171
NOP	
J	L_DoEthernet12
NOP	
L__DoEthernet171:
;Ethernet.c,177 :: 		if (socket_Intern[i].open == 0)
SEH	R3, R4
ORI	R2, R0, 56
MULTU	R2, R3
MFLO	R3
LUI	R2, #hi_addr(_socket_Intern+0)
ORI	R2, R2, #lo_addr(_socket_Intern+0)
ADDU	R2, R2, R3
ADDIU	R2, R2, 36
LBU	R2, 0(R2)
ANDI	R2, R2, 255
BEQ	R2, R0, L__DoEthernet172
NOP	
J	L_DoEthernet14
NOP	
L__DoEthernet172:
;Ethernet.c,178 :: 		pos[i] = 0;
SEH	R2, R4
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
SH	R0, 0(R2)
L_DoEthernet14:
;Ethernet.c,176 :: 		for (i = 0; i < NUM_OF_SOCKET_Intern; i++) {
ADDIU	R2, R4, 1
SEH	R4, R2
;Ethernet.c,179 :: 		}
; i end address is: 16 (R4)
J	L_DoEthernet11
NOP	
L_DoEthernet12:
;Ethernet.c,180 :: 		}
L_end_DoEthernet:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _DoEthernet
_Net_Ethernet_Intern_UserUDP:
;Ethernet.c,185 :: 		unsigned int Net_Ethernet_Intern_UserUDP(UDP_Intern_Dsc *udpDsc) {
ADDIU	SP, SP, -28
SW	RA, 0(SP)
;Ethernet.c,193 :: 		len = 0;  // Initialize len
SW	R26, 4(SP)
; len start address is: 16 (R4)
MOVZ	R4, R0, R0
;Ethernet.c,197 :: 		if (udpDsc->destPort == 6060) {  // We will listen for messages on this port
ADDIU	R2, R25, 12
LHU	R2, 0(R2)
ANDI	R3, R2, 65535
ORI	R2, R0, 6060
BEQ	R3, R2, L__Net_Ethernet_Intern_UserUDP174
NOP	
J	L__Net_Ethernet_Intern_UserUDP127
NOP	
L__Net_Ethernet_Intern_UserUDP174:
;Ethernet.c,199 :: 		if (udpDsc->dataLength < 60) {  // To prevent buffer overruns
ADDIU	R2, R25, 14
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 60
BNE	R2, R0, L__Net_Ethernet_Intern_UserUDP175
NOP	
J	L_Net_Ethernet_Intern_UserUDP16
NOP	
L__Net_Ethernet_Intern_UserUDP175:
;Ethernet.c,201 :: 		for (i=0; i<udpDsc->dataLength; i++) {  // Copy internal buffer
; i start address is: 20 (R5)
MOVZ	R5, R0, R0
; i end address is: 20 (R5)
; len end address is: 16 (R4)
L_Net_Ethernet_Intern_UserUDP17:
; i start address is: 20 (R5)
; len start address is: 16 (R4)
ADDIU	R2, R25, 14
LHU	R2, 0(R2)
ANDI	R3, R5, 65535
ANDI	R2, R2, 65535
SLTU	R2, R3, R2
BNE	R2, R0, L__Net_Ethernet_Intern_UserUDP176
NOP	
J	L_Net_Ethernet_Intern_UserUDP18
NOP	
L__Net_Ethernet_Intern_UserUDP176:
;Ethernet.c,202 :: 		UDP_Buffer[i] = Net_Ethernet_Intern_getByte();
ANDI	R3, R5, 65535
LUI	R2, #hi_addr(_UDP_Buffer+0)
ORI	R2, R2, #lo_addr(_UDP_Buffer+0)
ADDU	R2, R2, R3
SW	R2, 24(SP)
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
LW	R3, 24(SP)
SB	R2, 0(R3)
;Ethernet.c,201 :: 		for (i=0; i<udpDsc->dataLength; i++) {  // Copy internal buffer
ADDIU	R2, R5, 1
ANDI	R5, R2, 65535
;Ethernet.c,203 :: 		}
J	L_Net_Ethernet_Intern_UserUDP17
NOP	
L_Net_Ethernet_Intern_UserUDP18:
;Ethernet.c,204 :: 		UDP_Buffer[i] = 0;  // Add NUL character to end of buffer
ANDI	R3, R5, 65535
; i end address is: 20 (R5)
LUI	R2, #hi_addr(_UDP_Buffer+0)
ORI	R2, R2, #lo_addr(_UDP_Buffer+0)
ADDU	R2, R2, R3
SB	R0, 0(R2)
;Ethernet.c,206 :: 		switch (UDP_Buffer[0]) {  // First character is the command
J	L_Net_Ethernet_Intern_UserUDP20
NOP	
; len end address is: 16 (R4)
;Ethernet.c,208 :: 		case 'A':  // Show Date/Time
L_Net_Ethernet_Intern_UserUDP22:
;Ethernet.c,209 :: 		UART1_PutQueue("A command received\r\n");
SW	R25, 8(SP)
LUI	R25, #hi_addr(?lstr3_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr3_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,211 :: 		Month = ts1.mo;   // so put values into integer type
; Month start address is: 20 (R5)
LBU	R5, Offset(_ts1+5)(GP)
;Ethernet.c,212 :: 		Day = ts1.md;
; Day start address is: 24 (R6)
LBU	R6, Offset(_ts1+3)(GP)
;Ethernet.c,213 :: 		Hour = ts1.hh;
; Hour start address is: 28 (R7)
LBU	R7, Offset(_ts1+2)(GP)
;Ethernet.c,214 :: 		Minute = ts1.mn;
; Minute start address is: 32 (R8)
LBU	R8, Offset(_ts1+1)(GP)
;Ethernet.c,215 :: 		Second = ts1.ss;
; Second start address is: 36 (R9)
LBU	R9, Offset(_ts1+0)(GP)
;Ethernet.c,218 :: 		sprintf(UDP_Buffer,"%04d/%02d/%02d %02d:%02d:%02d\r\n",Year,Month,Day,Hour,Minute,Second);
LH	R4, Offset(_ts1+6)(GP)
LUI	R3, #hi_addr(?lstr_4_Ethernet+0)
ORI	R3, R3, #lo_addr(?lstr_4_Ethernet+0)
LUI	R2, #hi_addr(_UDP_Buffer+0)
ORI	R2, R2, #lo_addr(_UDP_Buffer+0)
; Second end address is: 36 (R9)
ADDIU	SP, SP, -32
SH	R9, 28(SP)
SH	R8, 24(SP)
; Minute end address is: 32 (R8)
SH	R7, 20(SP)
; Hour end address is: 28 (R7)
SH	R6, 16(SP)
; Day end address is: 24 (R6)
SH	R5, 12(SP)
; Month end address is: 20 (R5)
SH	R4, 8(SP)
SW	R3, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 32
;Ethernet.c,219 :: 		len = strlen(UDP_Buffer);
LUI	R25, #hi_addr(_UDP_Buffer+0)
ORI	R25, R25, #lo_addr(_UDP_Buffer+0)
JAL	_strlen+0
NOP	
; len start address is: 16 (R4)
SEH	R4, R2
;Ethernet.c,220 :: 		Net_Ethernet_Intern_putBytes(UDP_Buffer,len);
ANDI	R26, R2, 65535
LUI	R25, #hi_addr(_UDP_Buffer+0)
ORI	R25, R25, #lo_addr(_UDP_Buffer+0)
JAL	_Net_Ethernet_Intern_putBytes+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,221 :: 		break;
ANDI	R6, R4, 65535
; len end address is: 16 (R4)
J	L_Net_Ethernet_Intern_UserUDP21
NOP	
;Ethernet.c,223 :: 		case 'B':  // Set Date/Time
L_Net_Ethernet_Intern_UserUDP23:
;Ethernet.c,224 :: 		UART1_PutQueue("B command received\r\n");
SW	R25, 8(SP)
LUI	R25, #hi_addr(?lstr5_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr5_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,225 :: 		if (strlen(UDP_Buffer) == 24) {  // Quick check of buffer length
LUI	R25, #hi_addr(_UDP_Buffer+0)
ORI	R25, R25, #lo_addr(_UDP_Buffer+0)
JAL	_strlen+0
NOP	
LW	R25, 8(SP)
SEH	R3, R2
ORI	R2, R0, 24
BEQ	R3, R2, L__Net_Ethernet_Intern_UserUDP177
NOP	
J	L_Net_Ethernet_Intern_UserUDP24
NOP	
L__Net_Ethernet_Intern_UserUDP177:
;Ethernet.c,226 :: 		UART1_PutQueue("Setting date/time \r\n");
SW	R25, 8(SP)
LUI	R25, #hi_addr(?lstr6_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr6_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,227 :: 		String[2] = 0;
ADDIU	R4, SP, 16
SW	R4, 24(SP)
ADDIU	R2, R4, 2
SB	R0, 0(R2)
;Ethernet.c,229 :: 		String[0] = UDP_Buffer[2];
LBU	R2, Offset(_UDP_Buffer+2)(GP)
SB	R2, 0(R4)
;Ethernet.c,230 :: 		String[1] = UDP_Buffer[3];
ADDIU	R3, R4, 1
LBU	R2, Offset(_UDP_Buffer+3)(GP)
SB	R2, 0(R3)
;Ethernet.c,231 :: 		ts1.yy = 2000 + atoi(String);   // Year
MOVZ	R25, R4, R0
JAL	_atoi+0
NOP	
ADDIU	R2, R2, 2000
SH	R2, Offset(_ts1+6)(GP)
;Ethernet.c,233 :: 		String[0] = UDP_Buffer[5];
ADDIU	R3, SP, 16
LBU	R2, Offset(_UDP_Buffer+5)(GP)
SB	R2, 0(R3)
;Ethernet.c,234 :: 		String[1] = UDP_Buffer[6];
LW	R4, 24(SP)
ADDIU	R3, R4, 1
LBU	R2, Offset(_UDP_Buffer+6)(GP)
SB	R2, 0(R3)
;Ethernet.c,235 :: 		ts1.mo = atoi(String);          // Month
MOVZ	R25, R4, R0
JAL	_atoi+0
NOP	
SB	R2, Offset(_ts1+5)(GP)
;Ethernet.c,237 :: 		String[0] = UDP_Buffer[8];
ADDIU	R3, SP, 16
LBU	R2, Offset(_UDP_Buffer+8)(GP)
SB	R2, 0(R3)
;Ethernet.c,238 :: 		String[1] = UDP_Buffer[9];
LW	R4, 24(SP)
ADDIU	R3, R4, 1
LBU	R2, Offset(_UDP_Buffer+9)(GP)
SB	R2, 0(R3)
;Ethernet.c,239 :: 		ts1.md = atoi(String);          // Day of month
MOVZ	R25, R4, R0
JAL	_atoi+0
NOP	
SB	R2, Offset(_ts1+3)(GP)
;Ethernet.c,241 :: 		String[0] = UDP_Buffer[11];
ADDIU	R3, SP, 16
LBU	R2, Offset(_UDP_Buffer+11)(GP)
SB	R2, 0(R3)
;Ethernet.c,242 :: 		String[1] = UDP_Buffer[12];
LW	R4, 24(SP)
ADDIU	R3, R4, 1
LBU	R2, Offset(_UDP_Buffer+12)(GP)
SB	R2, 0(R3)
;Ethernet.c,243 :: 		Dow = atoi(String);             // Day of week
MOVZ	R25, R4, R0
JAL	_atoi+0
NOP	
LW	R25, 8(SP)
; DoW start address is: 16 (R4)
SEH	R4, R2
;Ethernet.c,245 :: 		switch (DoW) {                  // Translate between Delphi7 and mikroC
J	L_Net_Ethernet_Intern_UserUDP25
NOP	
; DoW end address is: 16 (R4)
;Ethernet.c,246 :: 		case 1: ts1.wd = 6; break;  // Sunday
L_Net_Ethernet_Intern_UserUDP27:
ORI	R2, R0, 6
SB	R2, Offset(_ts1+4)(GP)
J	L_Net_Ethernet_Intern_UserUDP26
NOP	
;Ethernet.c,247 :: 		case 2: ts1.wd = 0; break;  // Monday
L_Net_Ethernet_Intern_UserUDP28:
SB	R0, Offset(_ts1+4)(GP)
J	L_Net_Ethernet_Intern_UserUDP26
NOP	
;Ethernet.c,248 :: 		case 3: ts1.wd = 1; break;  // Tuesday
L_Net_Ethernet_Intern_UserUDP29:
ORI	R2, R0, 1
SB	R2, Offset(_ts1+4)(GP)
J	L_Net_Ethernet_Intern_UserUDP26
NOP	
;Ethernet.c,249 :: 		case 4: ts1.wd = 2; break;  // Wednesday
L_Net_Ethernet_Intern_UserUDP30:
ORI	R2, R0, 2
SB	R2, Offset(_ts1+4)(GP)
J	L_Net_Ethernet_Intern_UserUDP26
NOP	
;Ethernet.c,250 :: 		case 5: ts1.wd = 3; break;  // Thursday
L_Net_Ethernet_Intern_UserUDP31:
ORI	R2, R0, 3
SB	R2, Offset(_ts1+4)(GP)
J	L_Net_Ethernet_Intern_UserUDP26
NOP	
;Ethernet.c,251 :: 		case 6: ts1.wd = 4; break;  // Friday
L_Net_Ethernet_Intern_UserUDP32:
ORI	R2, R0, 4
SB	R2, Offset(_ts1+4)(GP)
J	L_Net_Ethernet_Intern_UserUDP26
NOP	
;Ethernet.c,252 :: 		case 7: ts1.wd = 5; break;  // Saturday
L_Net_Ethernet_Intern_UserUDP33:
ORI	R2, R0, 5
SB	R2, Offset(_ts1+4)(GP)
J	L_Net_Ethernet_Intern_UserUDP26
NOP	
;Ethernet.c,253 :: 		}
L_Net_Ethernet_Intern_UserUDP25:
; DoW start address is: 16 (R4)
SEH	R3, R4
ORI	R2, R0, 1
BNE	R3, R2, L__Net_Ethernet_Intern_UserUDP179
NOP	
J	L_Net_Ethernet_Intern_UserUDP27
NOP	
L__Net_Ethernet_Intern_UserUDP179:
SEH	R3, R4
ORI	R2, R0, 2
BNE	R3, R2, L__Net_Ethernet_Intern_UserUDP181
NOP	
J	L_Net_Ethernet_Intern_UserUDP28
NOP	
L__Net_Ethernet_Intern_UserUDP181:
SEH	R3, R4
ORI	R2, R0, 3
BNE	R3, R2, L__Net_Ethernet_Intern_UserUDP183
NOP	
J	L_Net_Ethernet_Intern_UserUDP29
NOP	
L__Net_Ethernet_Intern_UserUDP183:
SEH	R3, R4
ORI	R2, R0, 4
BNE	R3, R2, L__Net_Ethernet_Intern_UserUDP185
NOP	
J	L_Net_Ethernet_Intern_UserUDP30
NOP	
L__Net_Ethernet_Intern_UserUDP185:
SEH	R3, R4
ORI	R2, R0, 5
BNE	R3, R2, L__Net_Ethernet_Intern_UserUDP187
NOP	
J	L_Net_Ethernet_Intern_UserUDP31
NOP	
L__Net_Ethernet_Intern_UserUDP187:
SEH	R3, R4
ORI	R2, R0, 6
BNE	R3, R2, L__Net_Ethernet_Intern_UserUDP189
NOP	
J	L_Net_Ethernet_Intern_UserUDP32
NOP	
L__Net_Ethernet_Intern_UserUDP189:
SEH	R3, R4
; DoW end address is: 16 (R4)
ORI	R2, R0, 7
BNE	R3, R2, L__Net_Ethernet_Intern_UserUDP191
NOP	
J	L_Net_Ethernet_Intern_UserUDP33
NOP	
L__Net_Ethernet_Intern_UserUDP191:
L_Net_Ethernet_Intern_UserUDP26:
;Ethernet.c,255 :: 		String[0] = UDP_Buffer[14];
ADDIU	R4, SP, 16
SW	R4, 24(SP)
LBU	R2, Offset(_UDP_Buffer+14)(GP)
SB	R2, 0(R4)
;Ethernet.c,256 :: 		String[1] = UDP_Buffer[15];
ADDIU	R3, R4, 1
LBU	R2, Offset(_UDP_Buffer+15)(GP)
SB	R2, 0(R3)
;Ethernet.c,257 :: 		ts1.hh = atoi(String);          // Hours
SW	R25, 8(SP)
MOVZ	R25, R4, R0
JAL	_atoi+0
NOP	
SB	R2, Offset(_ts1+2)(GP)
;Ethernet.c,259 :: 		String[0] = UDP_Buffer[17];
ADDIU	R3, SP, 16
LBU	R2, Offset(_UDP_Buffer+17)(GP)
SB	R2, 0(R3)
;Ethernet.c,260 :: 		String[1] = UDP_Buffer[18];
LW	R4, 24(SP)
ADDIU	R3, R4, 1
LBU	R2, Offset(_UDP_Buffer+18)(GP)
SB	R2, 0(R3)
;Ethernet.c,261 :: 		ts1.mn = atoi(String);          // Minutes
MOVZ	R25, R4, R0
JAL	_atoi+0
NOP	
SB	R2, Offset(_ts1+1)(GP)
;Ethernet.c,263 :: 		String[0] = UDP_Buffer[20];
ADDIU	R3, SP, 16
LBU	R2, Offset(_UDP_Buffer+20)(GP)
SB	R2, 0(R3)
;Ethernet.c,264 :: 		String[1] = UDP_Buffer[21];
LW	R4, 24(SP)
ADDIU	R3, R4, 1
LBU	R2, Offset(_UDP_Buffer+21)(GP)
SB	R2, 0(R3)
;Ethernet.c,265 :: 		ts1.ss = atoi(String);          // Seconds
MOVZ	R25, R4, R0
JAL	_atoi+0
NOP	
SB	R2, Offset(_ts1+0)(GP)
;Ethernet.c,267 :: 		Epoch = Time_dateToEpoch(&ts1);
LUI	R25, #hi_addr(_ts1+0)
ORI	R25, R25, #lo_addr(_ts1+0)
JAL	_Time_dateToEpoch+0
NOP	
SW	R2, Offset(_Epoch+0)(GP)
;Ethernet.c,270 :: 		len = strlen(UDP_Message1);
LUI	R25, #hi_addr(_UDP_Message1+0)
ORI	R25, R25, #lo_addr(_UDP_Message1+0)
JAL	_strlen+0
NOP	
; len start address is: 16 (R4)
SEH	R4, R2
;Ethernet.c,271 :: 		Net_Ethernet_Intern_putBytes(UDP_Message1,len);
ANDI	R26, R2, 65535
LUI	R25, #hi_addr(_UDP_Message1+0)
ORI	R25, R25, #lo_addr(_UDP_Message1+0)
JAL	_Net_Ethernet_Intern_putBytes+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,273 :: 		} else {
ANDI	R2, R4, 65535
; len end address is: 16 (R4)
J	L_Net_Ethernet_Intern_UserUDP34
NOP	
L_Net_Ethernet_Intern_UserUDP24:
;Ethernet.c,274 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,275 :: 		sprintf(BufNum,"Incorrect length: %d \r\n",strlen(UDP_Buffer));
LUI	R25, #hi_addr(_UDP_Buffer+0)
ORI	R25, R25, #lo_addr(_UDP_Buffer+0)
JAL	_strlen+0
NOP	
LUI	R3, #hi_addr(?lstr_7_Ethernet+0)
ORI	R3, R3, #lo_addr(?lstr_7_Ethernet+0)
ADDIU	SP, SP, -12
SH	R2, 8(SP)
SW	R3, 4(SP)
SW	R20, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,276 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,279 :: 		len = strlen(UDP_Message2);
LUI	R25, #hi_addr(_UDP_Message2+0)
ORI	R25, R25, #lo_addr(_UDP_Message2+0)
JAL	_strlen+0
NOP	
LW	R25, 8(SP)
; len start address is: 12 (R3)
SEH	R3, R2
;Ethernet.c,280 :: 		Net_Ethernet_Intern_putBytes(UDP_Message2,len);
SH	R3, 8(SP)
SW	R25, 12(SP)
ANDI	R26, R2, 65535
LUI	R25, #hi_addr(_UDP_Message2+0)
ORI	R25, R25, #lo_addr(_UDP_Message2+0)
JAL	_Net_Ethernet_Intern_putBytes+0
NOP	
; len end address is: 12 (R3)
LW	R25, 12(SP)
LHU	R3, 8(SP)
ANDI	R2, R3, 65535
;Ethernet.c,281 :: 		}
L_Net_Ethernet_Intern_UserUDP34:
;Ethernet.c,282 :: 		break;
; len start address is: 8 (R2)
ANDI	R6, R2, 65535
; len end address is: 8 (R2)
J	L_Net_Ethernet_Intern_UserUDP21
NOP	
;Ethernet.c,284 :: 		default:
L_Net_Ethernet_Intern_UserUDP35:
;Ethernet.c,285 :: 		UART1_PutQueue("Unknown command\r\n");  // Diagnostic message
; len start address is: 16 (R4)
SH	R4, 8(SP)
SW	R25, 12(SP)
LUI	R25, #hi_addr(?lstr8_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr8_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 12(SP)
LHU	R4, 8(SP)
;Ethernet.c,286 :: 		break;
ANDI	R6, R4, 65535
J	L_Net_Ethernet_Intern_UserUDP21
NOP	
;Ethernet.c,287 :: 		}
L_Net_Ethernet_Intern_UserUDP20:
LBU	R3, Offset(_UDP_Buffer+0)(GP)
ORI	R2, R0, 65
BNE	R3, R2, L__Net_Ethernet_Intern_UserUDP193
NOP	
J	L_Net_Ethernet_Intern_UserUDP22
NOP	
L__Net_Ethernet_Intern_UserUDP193:
LBU	R3, Offset(_UDP_Buffer+0)(GP)
ORI	R2, R0, 66
BNE	R3, R2, L__Net_Ethernet_Intern_UserUDP195
NOP	
J	L_Net_Ethernet_Intern_UserUDP23
NOP	
L__Net_Ethernet_Intern_UserUDP195:
J	L_Net_Ethernet_Intern_UserUDP35
NOP	
; len end address is: 16 (R4)
L_Net_Ethernet_Intern_UserUDP21:
;Ethernet.c,289 :: 		} else {
; len start address is: 24 (R6)
; len end address is: 24 (R6)
J	L_Net_Ethernet_Intern_UserUDP36
NOP	
L_Net_Ethernet_Intern_UserUDP16:
;Ethernet.c,290 :: 		UART1_PutQueue("UDP message length exceeded\r\n");  // Diagnostic message
; len start address is: 16 (R4)
SH	R4, 8(SP)
SW	R25, 12(SP)
LUI	R25, #hi_addr(?lstr9_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr9_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
; len end address is: 16 (R4)
LW	R25, 12(SP)
LHU	R4, 8(SP)
ANDI	R6, R4, 65535
;Ethernet.c,291 :: 		}
L_Net_Ethernet_Intern_UserUDP36:
;Ethernet.c,293 :: 		BufNum = GetBuffer();
; len start address is: 24 (R6)
SH	R6, 8(SP)
SW	R25, 12(SP)
JAL	_GetBuffer+0
NOP	
LW	R25, 12(SP)
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,294 :: 		sprintf(BufNum,"Remote Port: %u  Destination Port: %u\r\n",udpDsc->remotePort,udpDsc->destPort);
ADDIU	R3, R25, 12
LHU	R5, 0(R3)
ADDIU	R3, R25, 10
LHU	R4, 0(R3)
LUI	R3, #hi_addr(?lstr_10_Ethernet+0)
ORI	R3, R3, #lo_addr(?lstr_10_Ethernet+0)
SW	R25, 12(SP)
ADDIU	SP, SP, -16
SH	R5, 12(SP)
SH	R4, 8(SP)
SW	R3, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 16
;Ethernet.c,295 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
; len end address is: 24 (R6)
LW	R25, 12(SP)
LHU	R6, 8(SP)
ANDI	R4, R6, 65535
;Ethernet.c,297 :: 		}
J	L_Net_Ethernet_Intern_UserUDP15
NOP	
L__Net_Ethernet_Intern_UserUDP127:
;Ethernet.c,197 :: 		if (udpDsc->destPort == 6060) {  // We will listen for messages on this port
;Ethernet.c,297 :: 		}
L_Net_Ethernet_Intern_UserUDP15:
;Ethernet.c,300 :: 		if (udpDsc->destPort == 123) {  // SNTP communicates on this port
; len start address is: 16 (R4)
ADDIU	R2, R25, 12
LHU	R2, 0(R2)
ANDI	R3, R2, 65535
ORI	R2, R0, 123
BEQ	R3, R2, L__Net_Ethernet_Intern_UserUDP196
NOP	
J	L__Net_Ethernet_Intern_UserUDP128
NOP	
L__Net_Ethernet_Intern_UserUDP196:
; len end address is: 16 (R4)
;Ethernet.c,302 :: 		SNTPTransmitFrame.ReceiveTS1 = Epoch-Fudge;  // Seconds since 1900
LW	R3, Offset(_Epoch+0)(GP)
LUI	R2, 33706
ORI	R2, R2, 32384
SUBU	R2, R3, R2
SW	R2, Offset(_SNTPTransmitFrame+32)(GP)
;Ethernet.c,304 :: 		SNTPTransmitFrame.ReceiveTS2 = (msec * 4294967296) / 1000; // SNTP Fraction = (Value in milliseconds * 2^32) / 10^3
LW	R6, Offset(_msec+0)(GP)
MOVZ	R7, R0, R0
LUI	R4, 0
ORI	R5, R0, 1
JAL	__Mul_64x64+0
NOP	
ORI	R6, R0, 1000
LUI	R7, 0
MOVZ	R4, R2, R0
MOVZ	R5, R3, R0
JAL	__Div_64x64_S+0
NOP	
SW	R2, Offset(_SNTPTransmitFrame+36)(GP)
;Ethernet.c,307 :: 		SNTPReceiveFrame.Flags = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+0)(GP)
;Ethernet.c,308 :: 		SNTPReceiveFrame.Flags <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+0)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+0)(GP)
;Ethernet.c,309 :: 		SNTPReceiveFrame.Flags |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+0)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+0)(GP)
;Ethernet.c,310 :: 		SNTPReceiveFrame.Flags <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+0)(GP)
;Ethernet.c,311 :: 		SNTPReceiveFrame.Flags |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+0)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+0)(GP)
;Ethernet.c,312 :: 		SNTPReceiveFrame.Flags <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+0)(GP)
;Ethernet.c,313 :: 		SNTPReceiveFrame.Flags |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+0)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+0)(GP)
;Ethernet.c,315 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,316 :: 		sprintf(BufNum,"Flags: %08LX\r\n",SNTPReceiveFrame.Flags);
LUI	R4, #hi_addr(?lstr_11_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_11_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+0)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,317 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,319 :: 		SNTPReceiveFrame.RootDelay = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+4)(GP)
;Ethernet.c,320 :: 		SNTPReceiveFrame.RootDelay <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+4)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+4)(GP)
;Ethernet.c,321 :: 		SNTPReceiveFrame.RootDelay |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+4)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+4)(GP)
;Ethernet.c,322 :: 		SNTPReceiveFrame.RootDelay <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+4)(GP)
;Ethernet.c,323 :: 		SNTPReceiveFrame.RootDelay |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+4)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+4)(GP)
;Ethernet.c,324 :: 		SNTPReceiveFrame.RootDelay <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+4)(GP)
;Ethernet.c,325 :: 		SNTPReceiveFrame.RootDelay |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+4)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+4)(GP)
;Ethernet.c,327 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,328 :: 		sprintf(BufNum,"RootDelay: %08LX\r\n",SNTPReceiveFrame.RootDelay);
LUI	R4, #hi_addr(?lstr_12_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_12_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+4)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,329 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,331 :: 		SNTPReceiveFrame.RootDispersion = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+8)(GP)
;Ethernet.c,332 :: 		SNTPReceiveFrame.RootDispersion <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+8)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+8)(GP)
;Ethernet.c,333 :: 		SNTPReceiveFrame.RootDispersion |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+8)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+8)(GP)
;Ethernet.c,334 :: 		SNTPReceiveFrame.RootDispersion <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+8)(GP)
;Ethernet.c,335 :: 		SNTPReceiveFrame.RootDispersion |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+8)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+8)(GP)
;Ethernet.c,336 :: 		SNTPReceiveFrame.RootDispersion <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+8)(GP)
;Ethernet.c,337 :: 		SNTPReceiveFrame.RootDispersion |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+8)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+8)(GP)
;Ethernet.c,339 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,340 :: 		sprintf(BufNum,"RootDispersion: %08LX\r\n",SNTPReceiveFrame.RootDispersion);
LUI	R4, #hi_addr(?lstr_13_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_13_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+8)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,341 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,343 :: 		SNTPReceiveFrame.ReferenceID = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+12)(GP)
;Ethernet.c,344 :: 		SNTPReceiveFrame.ReferenceID <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+12)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+12)(GP)
;Ethernet.c,345 :: 		SNTPReceiveFrame.ReferenceID |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+12)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+12)(GP)
;Ethernet.c,346 :: 		SNTPReceiveFrame.ReferenceID <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+12)(GP)
;Ethernet.c,347 :: 		SNTPReceiveFrame.ReferenceID |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+12)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+12)(GP)
;Ethernet.c,348 :: 		SNTPReceiveFrame.ReferenceID <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+12)(GP)
;Ethernet.c,349 :: 		SNTPReceiveFrame.ReferenceID |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+12)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+12)(GP)
;Ethernet.c,351 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,352 :: 		sprintf(BufNum,"ReferenceID: %08LX\r\n",SNTPReceiveFrame.ReferenceID);
LUI	R4, #hi_addr(?lstr_14_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_14_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+12)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,353 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,355 :: 		SNTPReceiveFrame.RefTS1 = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+16)(GP)
;Ethernet.c,356 :: 		SNTPReceiveFrame.RefTS1 <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+16)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+16)(GP)
;Ethernet.c,357 :: 		SNTPReceiveFrame.RefTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+16)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+16)(GP)
;Ethernet.c,358 :: 		SNTPReceiveFrame.RefTS1 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+16)(GP)
;Ethernet.c,359 :: 		SNTPReceiveFrame.RefTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+16)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+16)(GP)
;Ethernet.c,360 :: 		SNTPReceiveFrame.RefTS1 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+16)(GP)
;Ethernet.c,361 :: 		SNTPReceiveFrame.RefTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+16)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+16)(GP)
;Ethernet.c,363 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,364 :: 		sprintf(BufNum,"RefTS1: %08LX\r\n",SNTPReceiveFrame.RefTS1);
LUI	R4, #hi_addr(?lstr_15_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_15_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+16)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,365 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,367 :: 		SNTPReceiveFrame.RefTS2 = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+20)(GP)
;Ethernet.c,368 :: 		SNTPReceiveFrame.RefTS2 <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+20)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+20)(GP)
;Ethernet.c,369 :: 		SNTPReceiveFrame.RefTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+20)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+20)(GP)
;Ethernet.c,370 :: 		SNTPReceiveFrame.RefTS2 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+20)(GP)
;Ethernet.c,371 :: 		SNTPReceiveFrame.RefTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+20)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+20)(GP)
;Ethernet.c,372 :: 		SNTPReceiveFrame.RefTS2 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+20)(GP)
;Ethernet.c,373 :: 		SNTPReceiveFrame.RefTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+20)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+20)(GP)
;Ethernet.c,375 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,376 :: 		sprintf(BufNum,"RefTS2: %08LX\r\n",SNTPReceiveFrame.RefTS2);
LUI	R4, #hi_addr(?lstr_16_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_16_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+20)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,377 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,379 :: 		SNTPReceiveFrame.OriginTS1 = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+24)(GP)
;Ethernet.c,380 :: 		SNTPReceiveFrame.OriginTS1 <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+24)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+24)(GP)
;Ethernet.c,381 :: 		SNTPReceiveFrame.OriginTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+24)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+24)(GP)
;Ethernet.c,382 :: 		SNTPReceiveFrame.OriginTS1 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+24)(GP)
;Ethernet.c,383 :: 		SNTPReceiveFrame.OriginTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+24)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+24)(GP)
;Ethernet.c,384 :: 		SNTPReceiveFrame.OriginTS1 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+24)(GP)
;Ethernet.c,385 :: 		SNTPReceiveFrame.OriginTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+24)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+24)(GP)
;Ethernet.c,387 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,388 :: 		sprintf(BufNum,"OriginTS1: %08LX\r\n",SNTPReceiveFrame.OriginTS1);
LUI	R4, #hi_addr(?lstr_17_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_17_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+24)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,389 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,391 :: 		SNTPReceiveFrame.OriginTS2 = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+28)(GP)
;Ethernet.c,392 :: 		SNTPReceiveFrame.OriginTS2 <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+28)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+28)(GP)
;Ethernet.c,393 :: 		SNTPReceiveFrame.OriginTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+28)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+28)(GP)
;Ethernet.c,394 :: 		SNTPReceiveFrame.OriginTS2 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+28)(GP)
;Ethernet.c,395 :: 		SNTPReceiveFrame.OriginTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+28)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+28)(GP)
;Ethernet.c,396 :: 		SNTPReceiveFrame.OriginTS2 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+28)(GP)
;Ethernet.c,397 :: 		SNTPReceiveFrame.OriginTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+28)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+28)(GP)
;Ethernet.c,399 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,400 :: 		sprintf(BufNum,"OriginTS2: %08LX\r\n",SNTPReceiveFrame.OriginTS2);
LUI	R4, #hi_addr(?lstr_18_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_18_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+28)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,401 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,403 :: 		SNTPReceiveFrame.ReceiveTS1 = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+32)(GP)
;Ethernet.c,404 :: 		SNTPReceiveFrame.ReceiveTS1 <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+32)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+32)(GP)
;Ethernet.c,405 :: 		SNTPReceiveFrame.ReceiveTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+32)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+32)(GP)
;Ethernet.c,406 :: 		SNTPReceiveFrame.ReceiveTS1 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+32)(GP)
;Ethernet.c,407 :: 		SNTPReceiveFrame.ReceiveTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+32)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+32)(GP)
;Ethernet.c,408 :: 		SNTPReceiveFrame.ReceiveTS1 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+32)(GP)
;Ethernet.c,409 :: 		SNTPReceiveFrame.ReceiveTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+32)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+32)(GP)
;Ethernet.c,411 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,412 :: 		sprintf(BufNum,"ReceiveTS1: %08LX\r\n",SNTPReceiveFrame.ReceiveTS1);
LUI	R4, #hi_addr(?lstr_19_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_19_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+32)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,413 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,415 :: 		SNTPReceiveFrame.ReceiveTS2 = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+36)(GP)
;Ethernet.c,416 :: 		SNTPReceiveFrame.ReceiveTS2 <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+36)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+36)(GP)
;Ethernet.c,417 :: 		SNTPReceiveFrame.ReceiveTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+36)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+36)(GP)
;Ethernet.c,418 :: 		SNTPReceiveFrame.ReceiveTS2 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+36)(GP)
;Ethernet.c,419 :: 		SNTPReceiveFrame.ReceiveTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+36)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+36)(GP)
;Ethernet.c,420 :: 		SNTPReceiveFrame.ReceiveTS2 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+36)(GP)
;Ethernet.c,421 :: 		SNTPReceiveFrame.ReceiveTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+36)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+36)(GP)
;Ethernet.c,423 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,424 :: 		sprintf(BufNum,"ReceiveTS2: %08LX\r\n",SNTPReceiveFrame.ReceiveTS2);
LUI	R4, #hi_addr(?lstr_20_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_20_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+36)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,425 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,427 :: 		SNTPReceiveFrame.TransmitTS1 = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+40)(GP)
;Ethernet.c,428 :: 		SNTPReceiveFrame.TransmitTS1 <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+40)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+40)(GP)
;Ethernet.c,429 :: 		SNTPReceiveFrame.TransmitTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+40)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+40)(GP)
;Ethernet.c,430 :: 		SNTPReceiveFrame.TransmitTS1 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+40)(GP)
;Ethernet.c,431 :: 		SNTPReceiveFrame.TransmitTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+40)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+40)(GP)
;Ethernet.c,432 :: 		SNTPReceiveFrame.TransmitTS1 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+40)(GP)
;Ethernet.c,433 :: 		SNTPReceiveFrame.TransmitTS1 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+40)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+40)(GP)
;Ethernet.c,435 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,436 :: 		sprintf(BufNum,"TransmitTS1: %08LX\r\n",SNTPReceiveFrame.TransmitTS1);
LUI	R4, #hi_addr(?lstr_21_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_21_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+40)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,437 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,439 :: 		SNTPReceiveFrame.TransmitTS2 = Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R2, R2, 255
SW	R2, Offset(_SNTPReceiveFrame+44)(GP)
;Ethernet.c,440 :: 		SNTPReceiveFrame.TransmitTS2 <<= 8;
LW	R2, Offset(_SNTPReceiveFrame+44)(GP)
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+44)(GP)
;Ethernet.c,441 :: 		SNTPReceiveFrame.TransmitTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+44)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+44)(GP)
;Ethernet.c,442 :: 		SNTPReceiveFrame.TransmitTS2 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+44)(GP)
;Ethernet.c,443 :: 		SNTPReceiveFrame.TransmitTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+44)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+44)(GP)
;Ethernet.c,444 :: 		SNTPReceiveFrame.TransmitTS2 <<= 8;
SLL	R2, R2, 8
SW	R2, Offset(_SNTPReceiveFrame+44)(GP)
;Ethernet.c,445 :: 		SNTPReceiveFrame.TransmitTS2 |= Net_Ethernet_Intern_getByte();
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
ANDI	R3, R2, 255
LW	R2, Offset(_SNTPReceiveFrame+44)(GP)
OR	R2, R2, R3
SW	R2, Offset(_SNTPReceiveFrame+44)(GP)
;Ethernet.c,447 :: 		BufNum = GetBuffer();
SW	R25, 8(SP)
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,448 :: 		sprintf(BufNum,"TransmitTS2: %08LX\r\n\n",SNTPReceiveFrame.TransmitTS2);
LUI	R4, #hi_addr(?lstr_22_Ethernet+0)
ORI	R4, R4, #lo_addr(?lstr_22_Ethernet+0)
LW	R3, Offset(_SNTPReceiveFrame+44)(GP)
ADDIU	SP, SP, -12
SW	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;Ethernet.c,449 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,451 :: 		SNTPTransmitFrame.Flags = 0xDC000AFA;
LUI	R2, 56320
ORI	R2, R2, 2810
SW	R2, Offset(_SNTPTransmitFrame+0)(GP)
;Ethernet.c,452 :: 		SNTPTransmitFrame.RootDelay = 0;
SW	R0, Offset(_SNTPTransmitFrame+4)(GP)
;Ethernet.c,453 :: 		SNTPTransmitFrame.RootDispersion = 0x00010290;
LUI	R2, 1
ORI	R2, R2, 656
SW	R2, Offset(_SNTPTransmitFrame+8)(GP)
;Ethernet.c,455 :: 		SNTPTransmitFrame.ReferenceID = 0;
SW	R0, Offset(_SNTPTransmitFrame+12)(GP)
;Ethernet.c,456 :: 		SNTPTransmitFrame.RefTS1 = 0;
SW	R0, Offset(_SNTPTransmitFrame+16)(GP)
;Ethernet.c,457 :: 		SNTPTransmitFrame.RefTS2 = 0;
SW	R0, Offset(_SNTPTransmitFrame+20)(GP)
;Ethernet.c,458 :: 		SNTPTransmitFrame.OriginTS1 = SNTPReceiveFrame.TransmitTS1;
LW	R2, Offset(_SNTPReceiveFrame+40)(GP)
SW	R2, Offset(_SNTPTransmitFrame+24)(GP)
;Ethernet.c,459 :: 		SNTPTransmitFrame.OriginTS2 = SNTPReceiveFrame.TransmitTS2;
LW	R2, Offset(_SNTPReceiveFrame+44)(GP)
SW	R2, Offset(_SNTPTransmitFrame+28)(GP)
;Ethernet.c,462 :: 		SNTPTransmitFrame.TransmitTS1 = Epoch-Fudge;  // Seconds since 1900
LW	R3, Offset(_Epoch+0)(GP)
LUI	R2, 33706
ORI	R2, R2, 32384
SUBU	R2, R3, R2
SW	R2, Offset(_SNTPTransmitFrame+40)(GP)
;Ethernet.c,465 :: 		SNTPTransmitFrame.TransmitTS2 = (msec * 4294967296) / 1000; // SNTP Fraction = (Value in milliseconds * 2^32) / 10^3
LW	R6, Offset(_msec+0)(GP)
MOVZ	R7, R0, R0
LUI	R4, 0
ORI	R5, R0, 1
JAL	__Mul_64x64+0
NOP	
ORI	R6, R0, 1000
LUI	R7, 0
MOVZ	R4, R2, R0
MOVZ	R5, R3, R0
JAL	__Div_64x64_S+0
NOP	
SW	R2, Offset(_SNTPTransmitFrame+44)(GP)
;Ethernet.c,468 :: 		SNTP_TxBuffer[0] = (SNTPTransmitFrame.Flags >> 24);
LW	R4, Offset(_SNTPTransmitFrame+0)(GP)
SRL	R4, R4, 24
SB	R4, Offset(_SNTP_TxBuffer+0)(GP)
;Ethernet.c,469 :: 		SNTP_TxBuffer[1] = (SNTPTransmitFrame.Flags >> 16);
LW	R4, Offset(_SNTPTransmitFrame+0)(GP)
SRL	R4, R4, 16
SB	R4, Offset(_SNTP_TxBuffer+1)(GP)
;Ethernet.c,470 :: 		SNTP_TxBuffer[2] = (SNTPTransmitFrame.Flags >> 8);
LW	R4, Offset(_SNTPTransmitFrame+0)(GP)
SRL	R4, R4, 8
SB	R4, Offset(_SNTP_TxBuffer+2)(GP)
;Ethernet.c,471 :: 		SNTP_TxBuffer[3] = (SNTPTransmitFrame.Flags);
ORI	R4, R0, 250
SB	R4, Offset(_SNTP_TxBuffer+3)(GP)
;Ethernet.c,473 :: 		SNTP_TxBuffer[4] = (SNTPTransmitFrame.RootDelay >> 24);
LW	R4, Offset(_SNTPTransmitFrame+4)(GP)
SRL	R4, R4, 24
SB	R4, Offset(_SNTP_TxBuffer+4)(GP)
;Ethernet.c,474 :: 		SNTP_TxBuffer[5] = (SNTPTransmitFrame.RootDelay >> 16);
LW	R4, Offset(_SNTPTransmitFrame+4)(GP)
SRL	R4, R4, 16
SB	R4, Offset(_SNTP_TxBuffer+5)(GP)
;Ethernet.c,475 :: 		SNTP_TxBuffer[6] = (SNTPTransmitFrame.RootDelay >> 8);
LW	R4, Offset(_SNTPTransmitFrame+4)(GP)
SRL	R4, R4, 8
SB	R4, Offset(_SNTP_TxBuffer+6)(GP)
;Ethernet.c,476 :: 		SNTP_TxBuffer[7] = (SNTPTransmitFrame.RootDelay);
SB	R0, Offset(_SNTP_TxBuffer+7)(GP)
;Ethernet.c,478 :: 		SNTP_TxBuffer[8] = (SNTPTransmitFrame.RootDispersion >> 24);
LW	R4, Offset(_SNTPTransmitFrame+8)(GP)
SRL	R4, R4, 24
SB	R4, Offset(_SNTP_TxBuffer+8)(GP)
;Ethernet.c,479 :: 		SNTP_TxBuffer[9] = (SNTPTransmitFrame.RootDispersion >> 16);
LW	R4, Offset(_SNTPTransmitFrame+8)(GP)
SRL	R4, R4, 16
SB	R4, Offset(_SNTP_TxBuffer+9)(GP)
;Ethernet.c,480 :: 		SNTP_TxBuffer[10] = (SNTPTransmitFrame.RootDispersion >> 8);
LW	R4, Offset(_SNTPTransmitFrame+8)(GP)
SRL	R4, R4, 8
SB	R4, Offset(_SNTP_TxBuffer+10)(GP)
;Ethernet.c,481 :: 		SNTP_TxBuffer[11] = (SNTPTransmitFrame.RootDispersion);
ORI	R4, R0, 144
SB	R4, Offset(_SNTP_TxBuffer+11)(GP)
;Ethernet.c,483 :: 		SNTP_TxBuffer[12] = (SNTPTransmitFrame.ReferenceID >> 24);
LW	R4, Offset(_SNTPTransmitFrame+12)(GP)
SRL	R4, R4, 24
SB	R4, Offset(_SNTP_TxBuffer+12)(GP)
;Ethernet.c,484 :: 		SNTP_TxBuffer[13] = (SNTPTransmitFrame.ReferenceID >> 16);
LW	R4, Offset(_SNTPTransmitFrame+12)(GP)
SRL	R4, R4, 16
SB	R4, Offset(_SNTP_TxBuffer+13)(GP)
;Ethernet.c,485 :: 		SNTP_TxBuffer[14] = (SNTPTransmitFrame.ReferenceID >> 8);
LW	R4, Offset(_SNTPTransmitFrame+12)(GP)
SRL	R4, R4, 8
SB	R4, Offset(_SNTP_TxBuffer+14)(GP)
;Ethernet.c,486 :: 		SNTP_TxBuffer[15] = (SNTPTransmitFrame.ReferenceID);
SB	R0, Offset(_SNTP_TxBuffer+15)(GP)
;Ethernet.c,488 :: 		SNTP_TxBuffer[16] = (SNTPTransmitFrame.RefTS1 >> 24);
LW	R4, Offset(_SNTPTransmitFrame+16)(GP)
SRL	R4, R4, 24
SB	R4, Offset(_SNTP_TxBuffer+16)(GP)
;Ethernet.c,489 :: 		SNTP_TxBuffer[17] = (SNTPTransmitFrame.RefTS1 >> 16);
LW	R4, Offset(_SNTPTransmitFrame+16)(GP)
SRL	R4, R4, 16
SB	R4, Offset(_SNTP_TxBuffer+17)(GP)
;Ethernet.c,490 :: 		SNTP_TxBuffer[18] = (SNTPTransmitFrame.RefTS1 >> 8);
LW	R4, Offset(_SNTPTransmitFrame+16)(GP)
SRL	R4, R4, 8
SB	R4, Offset(_SNTP_TxBuffer+18)(GP)
;Ethernet.c,491 :: 		SNTP_TxBuffer[19] = (SNTPTransmitFrame.RefTS1);
SB	R0, Offset(_SNTP_TxBuffer+19)(GP)
;Ethernet.c,493 :: 		SNTP_TxBuffer[20] = (SNTPTransmitFrame.RefTS2 >> 24);
LW	R4, Offset(_SNTPTransmitFrame+20)(GP)
SRL	R4, R4, 24
SB	R4, Offset(_SNTP_TxBuffer+20)(GP)
;Ethernet.c,494 :: 		SNTP_TxBuffer[21] = (SNTPTransmitFrame.RefTS2 >> 16);
LW	R4, Offset(_SNTPTransmitFrame+20)(GP)
SRL	R4, R4, 16
SB	R4, Offset(_SNTP_TxBuffer+21)(GP)
;Ethernet.c,495 :: 		SNTP_TxBuffer[22] = (SNTPTransmitFrame.RefTS2 >> 8);
LW	R4, Offset(_SNTPTransmitFrame+20)(GP)
SRL	R4, R4, 8
SB	R4, Offset(_SNTP_TxBuffer+22)(GP)
;Ethernet.c,496 :: 		SNTP_TxBuffer[23] = (SNTPTransmitFrame.RefTS2);
SB	R0, Offset(_SNTP_TxBuffer+23)(GP)
;Ethernet.c,498 :: 		SNTP_TxBuffer[24] = (SNTPTransmitFrame.OriginTS1 >> 24);
LW	R4, Offset(_SNTPTransmitFrame+24)(GP)
SRL	R4, R4, 24
SB	R4, Offset(_SNTP_TxBuffer+24)(GP)
;Ethernet.c,499 :: 		SNTP_TxBuffer[25] = (SNTPTransmitFrame.OriginTS1 >> 16);
LW	R4, Offset(_SNTPTransmitFrame+24)(GP)
SRL	R4, R4, 16
SB	R4, Offset(_SNTP_TxBuffer+25)(GP)
;Ethernet.c,500 :: 		SNTP_TxBuffer[26] = (SNTPTransmitFrame.OriginTS1 >> 8);
LW	R4, Offset(_SNTPTransmitFrame+24)(GP)
SRL	R4, R4, 8
SB	R4, Offset(_SNTP_TxBuffer+26)(GP)
;Ethernet.c,501 :: 		SNTP_TxBuffer[27] = (SNTPTransmitFrame.OriginTS1);
LW	R4, Offset(_SNTPTransmitFrame+24)(GP)
SB	R4, Offset(_SNTP_TxBuffer+27)(GP)
;Ethernet.c,503 :: 		SNTP_TxBuffer[28] = (SNTPTransmitFrame.OriginTS2 >> 24);
LW	R4, Offset(_SNTPTransmitFrame+28)(GP)
SRL	R4, R4, 24
SB	R4, Offset(_SNTP_TxBuffer+28)(GP)
;Ethernet.c,504 :: 		SNTP_TxBuffer[29] = (SNTPTransmitFrame.OriginTS2 >> 16);
LW	R4, Offset(_SNTPTransmitFrame+28)(GP)
SRL	R4, R4, 16
SB	R4, Offset(_SNTP_TxBuffer+29)(GP)
;Ethernet.c,505 :: 		SNTP_TxBuffer[30] = (SNTPTransmitFrame.OriginTS2 >> 8);
LW	R4, Offset(_SNTPTransmitFrame+28)(GP)
SRL	R4, R4, 8
SB	R4, Offset(_SNTP_TxBuffer+30)(GP)
;Ethernet.c,506 :: 		SNTP_TxBuffer[31] = (SNTPTransmitFrame.OriginTS2);
LW	R4, Offset(_SNTPTransmitFrame+28)(GP)
SB	R4, Offset(_SNTP_TxBuffer+31)(GP)
;Ethernet.c,508 :: 		SNTP_TxBuffer[32] = (SNTPTransmitFrame.ReceiveTS1 >> 24);
LW	R4, Offset(_SNTPTransmitFrame+32)(GP)
SRL	R4, R4, 24
SB	R4, Offset(_SNTP_TxBuffer+32)(GP)
;Ethernet.c,509 :: 		SNTP_TxBuffer[33] = (SNTPTransmitFrame.ReceiveTS1 >> 16);
LW	R4, Offset(_SNTPTransmitFrame+32)(GP)
SRL	R4, R4, 16
SB	R4, Offset(_SNTP_TxBuffer+33)(GP)
;Ethernet.c,510 :: 		SNTP_TxBuffer[34] = (SNTPTransmitFrame.ReceiveTS1 >> 8);
LW	R4, Offset(_SNTPTransmitFrame+32)(GP)
SRL	R4, R4, 8
SB	R4, Offset(_SNTP_TxBuffer+34)(GP)
;Ethernet.c,511 :: 		SNTP_TxBuffer[35] = (SNTPTransmitFrame.ReceiveTS1);
LW	R4, Offset(_SNTPTransmitFrame+32)(GP)
SB	R4, Offset(_SNTP_TxBuffer+35)(GP)
;Ethernet.c,513 :: 		SNTP_TxBuffer[36] = (SNTPTransmitFrame.ReceiveTS2 >> 24);
LW	R4, Offset(_SNTPTransmitFrame+36)(GP)
SRL	R4, R4, 24
SB	R4, Offset(_SNTP_TxBuffer+36)(GP)
;Ethernet.c,514 :: 		SNTP_TxBuffer[37] = (SNTPTransmitFrame.ReceiveTS2 >> 16);
LW	R4, Offset(_SNTPTransmitFrame+36)(GP)
SRL	R4, R4, 16
SB	R4, Offset(_SNTP_TxBuffer+37)(GP)
;Ethernet.c,515 :: 		SNTP_TxBuffer[38] = (SNTPTransmitFrame.ReceiveTS2 >> 8);
LW	R4, Offset(_SNTPTransmitFrame+36)(GP)
SRL	R4, R4, 8
SB	R4, Offset(_SNTP_TxBuffer+38)(GP)
;Ethernet.c,516 :: 		SNTP_TxBuffer[39] = (SNTPTransmitFrame.ReceiveTS2);
LW	R4, Offset(_SNTPTransmitFrame+36)(GP)
SB	R4, Offset(_SNTP_TxBuffer+39)(GP)
;Ethernet.c,518 :: 		SNTP_TxBuffer[40] = (SNTPTransmitFrame.TransmitTS1 >> 24);
LW	R4, Offset(_SNTPTransmitFrame+40)(GP)
SRL	R4, R4, 24
SB	R4, Offset(_SNTP_TxBuffer+40)(GP)
;Ethernet.c,519 :: 		SNTP_TxBuffer[41] = (SNTPTransmitFrame.TransmitTS1 >> 16);
LW	R4, Offset(_SNTPTransmitFrame+40)(GP)
SRL	R4, R4, 16
SB	R4, Offset(_SNTP_TxBuffer+41)(GP)
;Ethernet.c,520 :: 		SNTP_TxBuffer[42] = (SNTPTransmitFrame.TransmitTS1 >> 8);
LW	R4, Offset(_SNTPTransmitFrame+40)(GP)
SRL	R4, R4, 8
SB	R4, Offset(_SNTP_TxBuffer+42)(GP)
;Ethernet.c,521 :: 		SNTP_TxBuffer[43] = (SNTPTransmitFrame.TransmitTS1);
LW	R4, Offset(_SNTPTransmitFrame+40)(GP)
SB	R4, Offset(_SNTP_TxBuffer+43)(GP)
;Ethernet.c,523 :: 		SNTP_TxBuffer[44] = (SNTPTransmitFrame.TransmitTS2 >> 24);
SRL	R4, R2, 24
SB	R4, Offset(_SNTP_TxBuffer+44)(GP)
;Ethernet.c,524 :: 		SNTP_TxBuffer[45] = (SNTPTransmitFrame.TransmitTS2 >> 16);
SRL	R4, R2, 16
SB	R4, Offset(_SNTP_TxBuffer+45)(GP)
;Ethernet.c,525 :: 		SNTP_TxBuffer[46] = (SNTPTransmitFrame.TransmitTS2 >> 8);
SRL	R4, R2, 8
SB	R4, Offset(_SNTP_TxBuffer+46)(GP)
;Ethernet.c,526 :: 		SNTP_TxBuffer[47] = (SNTPTransmitFrame.TransmitTS2);
SB	R2, Offset(_SNTP_TxBuffer+47)(GP)
;Ethernet.c,528 :: 		BufNum = GetBuffer();
JAL	_GetBuffer+0
NOP	
LW	R25, 8(SP)
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;Ethernet.c,529 :: 		sprintf(BufNum,"Remote Port: %u  Destination Port: %u\r\n",udpDsc->remotePort,udpDsc->destPort);
ADDIU	R3, R25, 12
LHU	R5, 0(R3)
ADDIU	R3, R25, 10
LHU	R4, 0(R3)
LUI	R3, #hi_addr(?lstr_23_Ethernet+0)
ORI	R3, R3, #lo_addr(?lstr_23_Ethernet+0)
SW	R25, 8(SP)
ADDIU	SP, SP, -16
SH	R5, 12(SP)
SH	R4, 8(SP)
SW	R3, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 16
;Ethernet.c,530 :: 		UART1_PutQueue(BufNum);
; BufNum end address is: 80 (R20)
MOVZ	R25, R20, R0
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 8(SP)
;Ethernet.c,532 :: 		len = 48;
; len start address is: 12 (R3)
ORI	R3, R0, 48
;Ethernet.c,533 :: 		Net_Ethernet_Intern_putBytes(SNTP_TxBuffer,len);
SH	R3, 8(SP)
SW	R25, 12(SP)
ORI	R26, R0, 48
LUI	R25, #hi_addr(_SNTP_TxBuffer+0)
ORI	R25, R25, #lo_addr(_SNTP_TxBuffer+0)
JAL	_Net_Ethernet_Intern_putBytes+0
NOP	
; len end address is: 12 (R3)
LW	R25, 12(SP)
LHU	R3, 8(SP)
;Ethernet.c,534 :: 		}
J	L_Net_Ethernet_Intern_UserUDP37
NOP	
L__Net_Ethernet_Intern_UserUDP128:
;Ethernet.c,300 :: 		if (udpDsc->destPort == 123) {  // SNTP communicates on this port
ANDI	R3, R4, 65535
;Ethernet.c,534 :: 		}
L_Net_Ethernet_Intern_UserUDP37:
;Ethernet.c,536 :: 		return(len);
; len start address is: 12 (R3)
ANDI	R2, R3, 65535
; len end address is: 12 (R3)
;Ethernet.c,537 :: 		}
;Ethernet.c,536 :: 		return(len);
;Ethernet.c,537 :: 		}
L_end_Net_Ethernet_Intern_UserUDP:
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 28
JR	RA
NOP	
; end of _Net_Ethernet_Intern_UserUDP
_Net_Ethernet_Intern_UserTCP:
;Ethernet.c,542 :: 		void Net_Ethernet_Intern_UserTCP(SOCKET_Intern_Dsc *socket) {
ADDIU	SP, SP, -24
SW	RA, 0(SP)
;Ethernet.c,548 :: 		if (socket->destPort == 80) {  // HTTP server listens only to web request on port 80
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
ADDIU	R2, R25, 12
LHU	R2, 0(R2)
ANDI	R3, R2, 65535
ORI	R2, R0, 80
BEQ	R3, R2, L__Net_Ethernet_Intern_UserTCP198
NOP	
J	L_Net_Ethernet_Intern_UserTCP38
NOP	
L__Net_Ethernet_Intern_UserTCP198:
;Ethernet.c,551 :: 		UART1_PutQueue("HTTP request received\r\n");
SW	R25, 16(SP)
LUI	R25, #hi_addr(?lstr24_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr24_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
LW	R25, 16(SP)
;Ethernet.c,554 :: 		for (len = 0; len < 10; len++) {
; len start address is: 20 (R5)
MOVZ	R5, R0, R0
; len end address is: 20 (R5)
L_Net_Ethernet_Intern_UserTCP39:
; len start address is: 20 (R5)
ANDI	R2, R5, 65535
SLTIU	R2, R2, 10
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP199
NOP	
J	L_Net_Ethernet_Intern_UserTCP40
NOP	
L__Net_Ethernet_Intern_UserTCP199:
;Ethernet.c,555 :: 		getRequest[len] = Net_Ethernet_Intern_getByte();
ANDI	R3, R5, 65535
LUI	R2, #hi_addr(_getRequest+0)
ORI	R2, R2, #lo_addr(_getRequest+0)
ADDU	R2, R2, R3
SW	R2, 20(SP)
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
LW	R3, 20(SP)
SB	R2, 0(R3)
;Ethernet.c,554 :: 		for (len = 0; len < 10; len++) {
ADDIU	R2, R5, 1
ANDI	R5, R2, 65535
;Ethernet.c,556 :: 		}
J	L_Net_Ethernet_Intern_UserTCP39
NOP	
L_Net_Ethernet_Intern_UserTCP40:
;Ethernet.c,557 :: 		getRequest[len] = 0;
ANDI	R3, R5, 65535
; len end address is: 20 (R5)
LUI	R2, #hi_addr(_getRequest+0)
ORI	R2, R2, #lo_addr(_getRequest+0)
ADDU	R2, R2, R3
SB	R0, 0(R2)
;Ethernet.c,560 :: 		if (memcmp(getRequest, httpMethod, 5) && (socket->state != 3)) {
SW	R25, 16(SP)
ORI	R27, R0, 5
LUI	R26, #hi_addr(_httpMethod+0)
ORI	R26, R26, #lo_addr(_httpMethod+0)
LUI	R25, #hi_addr(_getRequest+0)
ORI	R25, R25, #lo_addr(_getRequest+0)
JAL	_memcmp+0
NOP	
LW	R25, 16(SP)
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP201
NOP	
J	L__Net_Ethernet_Intern_UserTCP141
NOP	
L__Net_Ethernet_Intern_UserTCP201:
ADDIU	R2, R25, 39
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 3
BNE	R3, R2, L__Net_Ethernet_Intern_UserTCP203
NOP	
J	L__Net_Ethernet_Intern_UserTCP140
NOP	
L__Net_Ethernet_Intern_UserTCP203:
L__Net_Ethernet_Intern_UserTCP139:
;Ethernet.c,561 :: 		return;
J	L_end_Net_Ethernet_Intern_UserTCP
NOP	
;Ethernet.c,560 :: 		if (memcmp(getRequest, httpMethod, 5) && (socket->state != 3)) {
L__Net_Ethernet_Intern_UserTCP141:
L__Net_Ethernet_Intern_UserTCP140:
;Ethernet.c,564 :: 		if (memcmp(getRequest, httpRequ, 9) == 0) {
SW	R25, 16(SP)
ORI	R27, R0, 9
LUI	R26, #hi_addr(_httpRequ+0)
ORI	R26, R26, #lo_addr(_httpRequ+0)
LUI	R25, #hi_addr(_getRequest+0)
ORI	R25, R25, #lo_addr(_getRequest+0)
JAL	_memcmp+0
NOP	
LW	R25, 16(SP)
SEH	R2, R2
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP204
NOP	
J	L_Net_Ethernet_Intern_UserTCP45
NOP	
L__Net_Ethernet_Intern_UserTCP204:
;Ethernet.c,565 :: 		sendHTML_mark = 1;
ORI	R2, R0, 1
SB	R2, Offset(_sendHTML_mark+0)(GP)
;Ethernet.c,566 :: 		socketHTML = socket;
SW	R25, Offset(_socketHTML+0)(GP)
;Ethernet.c,567 :: 		}
L_Net_Ethernet_Intern_UserTCP45:
;Ethernet.c,570 :: 		if (getRequest[7] == 'p') {
LBU	R3, Offset(_getRequest+7)(GP)
ORI	R2, R0, 112
BEQ	R3, R2, L__Net_Ethernet_Intern_UserTCP205
NOP	
J	L_Net_Ethernet_Intern_UserTCP46
NOP	
L__Net_Ethernet_Intern_UserTCP205:
;Ethernet.c,571 :: 		switch(getRequest[8]) {
J	L_Net_Ethernet_Intern_UserTCP47
NOP	
;Ethernet.c,572 :: 		case '1': {send_mark1 = 1;  socketImage1 = socket; break;}
L_Net_Ethernet_Intern_UserTCP49:
ORI	R2, R0, 1
SB	R2, Offset(_send_mark1+0)(GP)
SW	R25, Offset(_socketImage1+0)(GP)
J	L_Net_Ethernet_Intern_UserTCP48
NOP	
;Ethernet.c,573 :: 		case '2': {send_mark2 = 1;  socketImage2 = socket; break;}
L_Net_Ethernet_Intern_UserTCP50:
ORI	R2, R0, 1
SB	R2, Offset(_send_mark2+0)(GP)
SW	R25, Offset(_socketImage2+0)(GP)
J	L_Net_Ethernet_Intern_UserTCP48
NOP	
;Ethernet.c,574 :: 		case '3': {send_mark3 = 1;  socketImage3 = socket; break;}
L_Net_Ethernet_Intern_UserTCP51:
ORI	R2, R0, 1
SB	R2, Offset(_send_mark3+0)(GP)
SW	R25, Offset(_socketImage3+0)(GP)
J	L_Net_Ethernet_Intern_UserTCP48
NOP	
;Ethernet.c,575 :: 		case '4': {send_mark4 = 1;  socketImage4 = socket; break;}
L_Net_Ethernet_Intern_UserTCP52:
ORI	R2, R0, 1
SB	R2, Offset(_send_mark4+0)(GP)
SW	R25, Offset(_socketImage4+0)(GP)
J	L_Net_Ethernet_Intern_UserTCP48
NOP	
;Ethernet.c,576 :: 		}
L_Net_Ethernet_Intern_UserTCP47:
LBU	R3, Offset(_getRequest+8)(GP)
ORI	R2, R0, 49
BNE	R3, R2, L__Net_Ethernet_Intern_UserTCP207
NOP	
J	L_Net_Ethernet_Intern_UserTCP49
NOP	
L__Net_Ethernet_Intern_UserTCP207:
LBU	R3, Offset(_getRequest+8)(GP)
ORI	R2, R0, 50
BNE	R3, R2, L__Net_Ethernet_Intern_UserTCP209
NOP	
J	L_Net_Ethernet_Intern_UserTCP50
NOP	
L__Net_Ethernet_Intern_UserTCP209:
LBU	R3, Offset(_getRequest+8)(GP)
ORI	R2, R0, 51
BNE	R3, R2, L__Net_Ethernet_Intern_UserTCP211
NOP	
J	L_Net_Ethernet_Intern_UserTCP51
NOP	
L__Net_Ethernet_Intern_UserTCP211:
LBU	R3, Offset(_getRequest+8)(GP)
ORI	R2, R0, 52
BNE	R3, R2, L__Net_Ethernet_Intern_UserTCP213
NOP	
J	L_Net_Ethernet_Intern_UserTCP52
NOP	
L__Net_Ethernet_Intern_UserTCP213:
L_Net_Ethernet_Intern_UserTCP48:
;Ethernet.c,577 :: 		}
L_Net_Ethernet_Intern_UserTCP46:
;Ethernet.c,581 :: 		if ((send_mark1 == 1) && (socketImage1 == socket)) {
LBU	R3, Offset(_send_mark1+0)(GP)
ORI	R2, R0, 1
BEQ	R3, R2, L__Net_Ethernet_Intern_UserTCP214
NOP	
J	L__Net_Ethernet_Intern_UserTCP145
NOP	
L__Net_Ethernet_Intern_UserTCP214:
LW	R2, Offset(_socketImage1+0)(GP)
BEQ	R2, R25, L__Net_Ethernet_Intern_UserTCP215
NOP	
J	L__Net_Ethernet_Intern_UserTCP144
NOP	
L__Net_Ethernet_Intern_UserTCP215:
L__Net_Ethernet_Intern_UserTCP138:
;Ethernet.c,583 :: 		if (pos[socket->ID] == 0)
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP216
NOP	
J	L_Net_Ethernet_Intern_UserTCP56
NOP	
L__Net_Ethernet_Intern_UserTCP216:
;Ethernet.c,584 :: 		Net_Ethernet_Intern_putConstStringTCP(httpImage, socket);
SW	R25, 16(SP)
MOVZ	R26, R25, R0
LUI	R25, #hi_addr(_httpImage+0)
ORI	R25, R25, #lo_addr(_httpImage+0)
JAL	_Net_Ethernet_Intern_putConstStringTCP+0
NOP	
LW	R25, 16(SP)
L_Net_Ethernet_Intern_UserTCP56:
;Ethernet.c,587 :: 		while (pos[socket->ID] < PICTURE1_SIZE) {
L_Net_Ethernet_Intern_UserTCP57:
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R3, R2, 65535
ORI	R2, R0, 46565
SLTU	R2, R3, R2
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP217
NOP	
J	L_Net_Ethernet_Intern_UserTCP58
NOP	
L__Net_Ethernet_Intern_UserTCP217:
;Ethernet.c,590 :: 		if (Net_Ethernet_Intern_putByteTCP(p1[  pos[socket->ID]++  ], socket) == 0) {
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R4, R2, R3
LHU	R3, 0(R4)
ADDIU	R2, R3, 1
SH	R2, 0(R4)
ANDI	R3, R3, 65535
LUI	R2, #hi_addr(_p1+0)
ORI	R2, R2, #lo_addr(_p1+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
SW	R25, 16(SP)
MOVZ	R26, R25, R0
ANDI	R25, R2, 255
JAL	_Net_Ethernet_Intern_putByteTCP+0
NOP	
LW	R25, 16(SP)
ANDI	R2, R2, 255
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP218
NOP	
J	L_Net_Ethernet_Intern_UserTCP59
NOP	
L__Net_Ethernet_Intern_UserTCP218:
;Ethernet.c,593 :: 		pos[socket->ID]--;
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R3, R2, R3
LHU	R2, 0(R3)
ADDIU	R2, R2, -1
SH	R2, 0(R3)
;Ethernet.c,594 :: 		break;
J	L_Net_Ethernet_Intern_UserTCP58
NOP	
;Ethernet.c,595 :: 		}
L_Net_Ethernet_Intern_UserTCP59:
;Ethernet.c,596 :: 		}
J	L_Net_Ethernet_Intern_UserTCP57
NOP	
L_Net_Ethernet_Intern_UserTCP58:
;Ethernet.c,598 :: 		if (Net_Ethernet_Intern_bufferEmptyTCP(socket) && (pos[socket->ID] >= PICTURE1_SIZE)) {
JAL	_Net_Ethernet_Intern_bufferEmptyTCP+0
NOP	
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP220
NOP	
J	L__Net_Ethernet_Intern_UserTCP143
NOP	
L__Net_Ethernet_Intern_UserTCP220:
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R3, R2, 65535
ORI	R2, R0, 46565
SLTU	R2, R3, R2
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP221
NOP	
J	L__Net_Ethernet_Intern_UserTCP142
NOP	
L__Net_Ethernet_Intern_UserTCP221:
L__Net_Ethernet_Intern_UserTCP137:
;Ethernet.c,599 :: 		Net_Ethernet_Intern_disconnectTCP(socket);
SW	R25, 16(SP)
JAL	_Net_Ethernet_Intern_disconnectTCP+0
NOP	
LW	R25, 16(SP)
;Ethernet.c,600 :: 		send_mark1 = 0;
SB	R0, Offset(_send_mark1+0)(GP)
;Ethernet.c,601 :: 		pos[socket->ID] = 0;
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
SH	R0, 0(R2)
;Ethernet.c,598 :: 		if (Net_Ethernet_Intern_bufferEmptyTCP(socket) && (pos[socket->ID] >= PICTURE1_SIZE)) {
L__Net_Ethernet_Intern_UserTCP143:
L__Net_Ethernet_Intern_UserTCP142:
;Ethernet.c,581 :: 		if ((send_mark1 == 1) && (socketImage1 == socket)) {
L__Net_Ethernet_Intern_UserTCP145:
L__Net_Ethernet_Intern_UserTCP144:
;Ethernet.c,607 :: 		if ((send_mark2 == 1) && (socketImage2 == socket)) {
LBU	R3, Offset(_send_mark2+0)(GP)
ORI	R2, R0, 1
BEQ	R3, R2, L__Net_Ethernet_Intern_UserTCP222
NOP	
J	L__Net_Ethernet_Intern_UserTCP149
NOP	
L__Net_Ethernet_Intern_UserTCP222:
LW	R2, Offset(_socketImage2+0)(GP)
BEQ	R2, R25, L__Net_Ethernet_Intern_UserTCP223
NOP	
J	L__Net_Ethernet_Intern_UserTCP148
NOP	
L__Net_Ethernet_Intern_UserTCP223:
L__Net_Ethernet_Intern_UserTCP136:
;Ethernet.c,608 :: 		if (pos[socket->ID] == 0)
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP224
NOP	
J	L_Net_Ethernet_Intern_UserTCP66
NOP	
L__Net_Ethernet_Intern_UserTCP224:
;Ethernet.c,609 :: 		Net_Ethernet_Intern_putConstStringTCP(httpImage, socket);
SW	R25, 16(SP)
MOVZ	R26, R25, R0
LUI	R25, #hi_addr(_httpImage+0)
ORI	R25, R25, #lo_addr(_httpImage+0)
JAL	_Net_Ethernet_Intern_putConstStringTCP+0
NOP	
LW	R25, 16(SP)
L_Net_Ethernet_Intern_UserTCP66:
;Ethernet.c,611 :: 		while (pos[socket->ID] < PICTURE2_SIZE) {
L_Net_Ethernet_Intern_UserTCP67:
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 5168
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP225
NOP	
J	L_Net_Ethernet_Intern_UserTCP68
NOP	
L__Net_Ethernet_Intern_UserTCP225:
;Ethernet.c,612 :: 		if (Net_Ethernet_Intern_putByteTCP(p2[pos[socket->ID]++], socket) == 0) {
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R4, R2, R3
LHU	R3, 0(R4)
ADDIU	R2, R3, 1
SH	R2, 0(R4)
ANDI	R3, R3, 65535
LUI	R2, #hi_addr(_p2+0)
ORI	R2, R2, #lo_addr(_p2+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
SW	R25, 16(SP)
MOVZ	R26, R25, R0
ANDI	R25, R2, 255
JAL	_Net_Ethernet_Intern_putByteTCP+0
NOP	
LW	R25, 16(SP)
ANDI	R2, R2, 255
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP226
NOP	
J	L_Net_Ethernet_Intern_UserTCP69
NOP	
L__Net_Ethernet_Intern_UserTCP226:
;Ethernet.c,613 :: 		pos[socket->ID]--;
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R3, R2, R3
LHU	R2, 0(R3)
ADDIU	R2, R2, -1
SH	R2, 0(R3)
;Ethernet.c,614 :: 		break;
J	L_Net_Ethernet_Intern_UserTCP68
NOP	
;Ethernet.c,615 :: 		}
L_Net_Ethernet_Intern_UserTCP69:
;Ethernet.c,616 :: 		}
J	L_Net_Ethernet_Intern_UserTCP67
NOP	
L_Net_Ethernet_Intern_UserTCP68:
;Ethernet.c,617 :: 		if (Net_Ethernet_Intern_bufferEmptyTCP(socket) && (pos[socket->ID] >= PICTURE2_SIZE)) {
JAL	_Net_Ethernet_Intern_bufferEmptyTCP+0
NOP	
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP228
NOP	
J	L__Net_Ethernet_Intern_UserTCP147
NOP	
L__Net_Ethernet_Intern_UserTCP228:
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 5168
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP229
NOP	
J	L__Net_Ethernet_Intern_UserTCP146
NOP	
L__Net_Ethernet_Intern_UserTCP229:
L__Net_Ethernet_Intern_UserTCP135:
;Ethernet.c,618 :: 		Net_Ethernet_Intern_disconnectTCP(socket);
SW	R25, 16(SP)
JAL	_Net_Ethernet_Intern_disconnectTCP+0
NOP	
LW	R25, 16(SP)
;Ethernet.c,619 :: 		send_mark2 = 0;
SB	R0, Offset(_send_mark2+0)(GP)
;Ethernet.c,620 :: 		pos[socket->ID] = 0;
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
SH	R0, 0(R2)
;Ethernet.c,617 :: 		if (Net_Ethernet_Intern_bufferEmptyTCP(socket) && (pos[socket->ID] >= PICTURE2_SIZE)) {
L__Net_Ethernet_Intern_UserTCP147:
L__Net_Ethernet_Intern_UserTCP146:
;Ethernet.c,607 :: 		if ((send_mark2 == 1) && (socketImage2 == socket)) {
L__Net_Ethernet_Intern_UserTCP149:
L__Net_Ethernet_Intern_UserTCP148:
;Ethernet.c,626 :: 		if ((send_mark3 == 1) && (socketImage3 == socket)) {
LBU	R3, Offset(_send_mark3+0)(GP)
ORI	R2, R0, 1
BEQ	R3, R2, L__Net_Ethernet_Intern_UserTCP230
NOP	
J	L__Net_Ethernet_Intern_UserTCP153
NOP	
L__Net_Ethernet_Intern_UserTCP230:
LW	R2, Offset(_socketImage3+0)(GP)
BEQ	R2, R25, L__Net_Ethernet_Intern_UserTCP231
NOP	
J	L__Net_Ethernet_Intern_UserTCP152
NOP	
L__Net_Ethernet_Intern_UserTCP231:
L__Net_Ethernet_Intern_UserTCP134:
;Ethernet.c,627 :: 		if (pos[socket->ID] == 0)
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP232
NOP	
J	L_Net_Ethernet_Intern_UserTCP76
NOP	
L__Net_Ethernet_Intern_UserTCP232:
;Ethernet.c,628 :: 		Net_Ethernet_Intern_putConstStringTCP(httpImage, socket);
SW	R25, 16(SP)
MOVZ	R26, R25, R0
LUI	R25, #hi_addr(_httpImage+0)
ORI	R25, R25, #lo_addr(_httpImage+0)
JAL	_Net_Ethernet_Intern_putConstStringTCP+0
NOP	
LW	R25, 16(SP)
L_Net_Ethernet_Intern_UserTCP76:
;Ethernet.c,630 :: 		while (pos[socket->ID] < PICTURE3_SIZE) {
L_Net_Ethernet_Intern_UserTCP77:
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 4103
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP233
NOP	
J	L_Net_Ethernet_Intern_UserTCP78
NOP	
L__Net_Ethernet_Intern_UserTCP233:
;Ethernet.c,631 :: 		if (Net_Ethernet_Intern_putByteTCP(p3[pos[socket->ID]++], socket) == 0) {
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R4, R2, R3
LHU	R3, 0(R4)
ADDIU	R2, R3, 1
SH	R2, 0(R4)
ANDI	R3, R3, 65535
LUI	R2, #hi_addr(_p3+0)
ORI	R2, R2, #lo_addr(_p3+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
SW	R25, 16(SP)
MOVZ	R26, R25, R0
ANDI	R25, R2, 255
JAL	_Net_Ethernet_Intern_putByteTCP+0
NOP	
LW	R25, 16(SP)
ANDI	R2, R2, 255
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP234
NOP	
J	L_Net_Ethernet_Intern_UserTCP79
NOP	
L__Net_Ethernet_Intern_UserTCP234:
;Ethernet.c,632 :: 		pos[socket->ID]--;
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R3, R2, R3
LHU	R2, 0(R3)
ADDIU	R2, R2, -1
SH	R2, 0(R3)
;Ethernet.c,633 :: 		break;
J	L_Net_Ethernet_Intern_UserTCP78
NOP	
;Ethernet.c,634 :: 		}
L_Net_Ethernet_Intern_UserTCP79:
;Ethernet.c,635 :: 		}
J	L_Net_Ethernet_Intern_UserTCP77
NOP	
L_Net_Ethernet_Intern_UserTCP78:
;Ethernet.c,636 :: 		if (Net_Ethernet_Intern_bufferEmptyTCP(socket) && (pos[socket->ID] >= PICTURE3_SIZE)) {
JAL	_Net_Ethernet_Intern_bufferEmptyTCP+0
NOP	
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP236
NOP	
J	L__Net_Ethernet_Intern_UserTCP151
NOP	
L__Net_Ethernet_Intern_UserTCP236:
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 4103
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP237
NOP	
J	L__Net_Ethernet_Intern_UserTCP150
NOP	
L__Net_Ethernet_Intern_UserTCP237:
L__Net_Ethernet_Intern_UserTCP133:
;Ethernet.c,637 :: 		Net_Ethernet_Intern_disconnectTCP(socket);
SW	R25, 16(SP)
JAL	_Net_Ethernet_Intern_disconnectTCP+0
NOP	
LW	R25, 16(SP)
;Ethernet.c,638 :: 		send_mark3 = 0;
SB	R0, Offset(_send_mark3+0)(GP)
;Ethernet.c,639 :: 		pos[socket->ID] = 0;
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
SH	R0, 0(R2)
;Ethernet.c,636 :: 		if (Net_Ethernet_Intern_bufferEmptyTCP(socket) && (pos[socket->ID] >= PICTURE3_SIZE)) {
L__Net_Ethernet_Intern_UserTCP151:
L__Net_Ethernet_Intern_UserTCP150:
;Ethernet.c,626 :: 		if ((send_mark3 == 1) && (socketImage3 == socket)) {
L__Net_Ethernet_Intern_UserTCP153:
L__Net_Ethernet_Intern_UserTCP152:
;Ethernet.c,645 :: 		if ((send_mark4 == 1) && (socketImage4 == socket)){
LBU	R3, Offset(_send_mark4+0)(GP)
ORI	R2, R0, 1
BEQ	R3, R2, L__Net_Ethernet_Intern_UserTCP238
NOP	
J	L__Net_Ethernet_Intern_UserTCP157
NOP	
L__Net_Ethernet_Intern_UserTCP238:
LW	R2, Offset(_socketImage4+0)(GP)
BEQ	R2, R25, L__Net_Ethernet_Intern_UserTCP239
NOP	
J	L__Net_Ethernet_Intern_UserTCP156
NOP	
L__Net_Ethernet_Intern_UserTCP239:
L__Net_Ethernet_Intern_UserTCP132:
;Ethernet.c,646 :: 		if (pos[socket->ID] == 0)
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP240
NOP	
J	L_Net_Ethernet_Intern_UserTCP86
NOP	
L__Net_Ethernet_Intern_UserTCP240:
;Ethernet.c,647 :: 		Net_Ethernet_Intern_putConstStringTCP(httpImage, socket);
SW	R25, 16(SP)
MOVZ	R26, R25, R0
LUI	R25, #hi_addr(_httpImage+0)
ORI	R25, R25, #lo_addr(_httpImage+0)
JAL	_Net_Ethernet_Intern_putConstStringTCP+0
NOP	
LW	R25, 16(SP)
L_Net_Ethernet_Intern_UserTCP86:
;Ethernet.c,649 :: 		while (pos[socket->ID] < PICTURE4_SIZE) {
L_Net_Ethernet_Intern_UserTCP87:
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 3778
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP241
NOP	
J	L_Net_Ethernet_Intern_UserTCP88
NOP	
L__Net_Ethernet_Intern_UserTCP241:
;Ethernet.c,650 :: 		if (Net_Ethernet_Intern_putByteTCP(p4[pos[socket->ID]++], socket) == 0) {
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R4, R2, R3
LHU	R3, 0(R4)
ADDIU	R2, R3, 1
SH	R2, 0(R4)
ANDI	R3, R3, 65535
LUI	R2, #hi_addr(_p4+0)
ORI	R2, R2, #lo_addr(_p4+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
SW	R25, 16(SP)
MOVZ	R26, R25, R0
ANDI	R25, R2, 255
JAL	_Net_Ethernet_Intern_putByteTCP+0
NOP	
LW	R25, 16(SP)
ANDI	R2, R2, 255
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP242
NOP	
J	L_Net_Ethernet_Intern_UserTCP89
NOP	
L__Net_Ethernet_Intern_UserTCP242:
;Ethernet.c,651 :: 		pos[socket->ID]--;
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R3, R2, R3
LHU	R2, 0(R3)
ADDIU	R2, R2, -1
SH	R2, 0(R3)
;Ethernet.c,652 :: 		break;
J	L_Net_Ethernet_Intern_UserTCP88
NOP	
;Ethernet.c,653 :: 		}
L_Net_Ethernet_Intern_UserTCP89:
;Ethernet.c,654 :: 		}
J	L_Net_Ethernet_Intern_UserTCP87
NOP	
L_Net_Ethernet_Intern_UserTCP88:
;Ethernet.c,655 :: 		if (Net_Ethernet_Intern_bufferEmptyTCP(socket) && (pos[socket->ID] >= PICTURE4_SIZE)) {
JAL	_Net_Ethernet_Intern_bufferEmptyTCP+0
NOP	
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP244
NOP	
J	L__Net_Ethernet_Intern_UserTCP155
NOP	
L__Net_Ethernet_Intern_UserTCP244:
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 3778
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP245
NOP	
J	L__Net_Ethernet_Intern_UserTCP154
NOP	
L__Net_Ethernet_Intern_UserTCP245:
L__Net_Ethernet_Intern_UserTCP131:
;Ethernet.c,656 :: 		Net_Ethernet_Intern_disconnectTCP(socket);
SW	R25, 16(SP)
JAL	_Net_Ethernet_Intern_disconnectTCP+0
NOP	
LW	R25, 16(SP)
;Ethernet.c,657 :: 		send_mark4 = 0;
SB	R0, Offset(_send_mark4+0)(GP)
;Ethernet.c,658 :: 		pos[socket->ID] = 0;
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
SH	R0, 0(R2)
;Ethernet.c,655 :: 		if (Net_Ethernet_Intern_bufferEmptyTCP(socket) && (pos[socket->ID] >= PICTURE4_SIZE)) {
L__Net_Ethernet_Intern_UserTCP155:
L__Net_Ethernet_Intern_UserTCP154:
;Ethernet.c,645 :: 		if ((send_mark4 == 1) && (socketImage4 == socket)){
L__Net_Ethernet_Intern_UserTCP157:
L__Net_Ethernet_Intern_UserTCP156:
;Ethernet.c,664 :: 		if ((sendHTML_mark == 1) && (socketHTML == socket)) {
LBU	R3, Offset(_sendHTML_mark+0)(GP)
ORI	R2, R0, 1
BEQ	R3, R2, L__Net_Ethernet_Intern_UserTCP246
NOP	
J	L__Net_Ethernet_Intern_UserTCP161
NOP	
L__Net_Ethernet_Intern_UserTCP246:
LW	R2, Offset(_socketHTML+0)(GP)
BEQ	R2, R25, L__Net_Ethernet_Intern_UserTCP247
NOP	
J	L__Net_Ethernet_Intern_UserTCP160
NOP	
L__Net_Ethernet_Intern_UserTCP247:
L__Net_Ethernet_Intern_UserTCP130:
;Ethernet.c,665 :: 		if (pos[socket->ID] == 0) {
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP248
NOP	
J	L_Net_Ethernet_Intern_UserTCP96
NOP	
L__Net_Ethernet_Intern_UserTCP248:
;Ethernet.c,667 :: 		Net_Ethernet_Intern_putConstStringTCP(httpHeader, socket);
SW	R25, 16(SP)
MOVZ	R26, R25, R0
LUI	R25, #hi_addr(_httpHeader+0)
ORI	R25, R25, #lo_addr(_httpHeader+0)
JAL	_Net_Ethernet_Intern_putConstStringTCP+0
NOP	
LW	R25, 16(SP)
;Ethernet.c,668 :: 		Net_Ethernet_Intern_putConstStringTCP(httpMimeTypeHTML, socket);
SW	R25, 16(SP)
MOVZ	R26, R25, R0
LUI	R25, #hi_addr(_httpMimeTypeHTML+0)
ORI	R25, R25, #lo_addr(_httpMimeTypeHTML+0)
JAL	_Net_Ethernet_Intern_putConstStringTCP+0
NOP	
LW	R25, 16(SP)
;Ethernet.c,669 :: 		}
L_Net_Ethernet_Intern_UserTCP96:
;Ethernet.c,670 :: 		while (pos[socket->ID] < HTML_CODE_SIZE) {
L_Net_Ethernet_Intern_UserTCP97:
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 7501
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP249
NOP	
J	L_Net_Ethernet_Intern_UserTCP98
NOP	
L__Net_Ethernet_Intern_UserTCP249:
;Ethernet.c,671 :: 		if (Net_Ethernet_Intern_putByteTCP(html_code[pos[socket->ID]++], socket) == 0) {
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R4, R2, R3
LHU	R3, 0(R4)
ADDIU	R2, R3, 1
SH	R2, 0(R4)
ANDI	R3, R3, 65535
LUI	R2, #hi_addr(_html_code+0)
ORI	R2, R2, #lo_addr(_html_code+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
SW	R25, 16(SP)
MOVZ	R26, R25, R0
ANDI	R25, R2, 255
JAL	_Net_Ethernet_Intern_putByteTCP+0
NOP	
LW	R25, 16(SP)
ANDI	R2, R2, 255
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP250
NOP	
J	L_Net_Ethernet_Intern_UserTCP99
NOP	
L__Net_Ethernet_Intern_UserTCP250:
;Ethernet.c,672 :: 		pos[socket->ID]--;
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R3, R2, R3
LHU	R2, 0(R3)
ADDIU	R2, R2, -1
SH	R2, 0(R3)
;Ethernet.c,673 :: 		break;
J	L_Net_Ethernet_Intern_UserTCP98
NOP	
;Ethernet.c,674 :: 		}
L_Net_Ethernet_Intern_UserTCP99:
;Ethernet.c,675 :: 		}
J	L_Net_Ethernet_Intern_UserTCP97
NOP	
L_Net_Ethernet_Intern_UserTCP98:
;Ethernet.c,676 :: 		if (Net_Ethernet_Intern_bufferEmptyTCP(socket) && (pos[socket->ID] >= HTML_CODE_SIZE)) {
JAL	_Net_Ethernet_Intern_bufferEmptyTCP+0
NOP	
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP252
NOP	
J	L__Net_Ethernet_Intern_UserTCP159
NOP	
L__Net_Ethernet_Intern_UserTCP252:
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
SLTIU	R2, R2, 7501
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP253
NOP	
J	L__Net_Ethernet_Intern_UserTCP158
NOP	
L__Net_Ethernet_Intern_UserTCP253:
L__Net_Ethernet_Intern_UserTCP129:
;Ethernet.c,677 :: 		Net_Ethernet_Intern_disconnectTCP(socket);
SW	R25, 16(SP)
JAL	_Net_Ethernet_Intern_disconnectTCP+0
NOP	
LW	R25, 16(SP)
;Ethernet.c,678 :: 		sendHTML_mark = 0;
SB	R0, Offset(_sendHTML_mark+0)(GP)
;Ethernet.c,679 :: 		pos[socket->ID] = 0;
ADDIU	R2, R25, 37
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 1
LUI	R2, #hi_addr(_pos+0)
ORI	R2, R2, #lo_addr(_pos+0)
ADDU	R2, R2, R3
SH	R0, 0(R2)
;Ethernet.c,676 :: 		if (Net_Ethernet_Intern_bufferEmptyTCP(socket) && (pos[socket->ID] >= HTML_CODE_SIZE)) {
L__Net_Ethernet_Intern_UserTCP159:
L__Net_Ethernet_Intern_UserTCP158:
;Ethernet.c,664 :: 		if ((sendHTML_mark == 1) && (socketHTML == socket)) {
L__Net_Ethernet_Intern_UserTCP161:
L__Net_Ethernet_Intern_UserTCP160:
;Ethernet.c,685 :: 		} else if (socketTCP_Client == socket) {
J	L_Net_Ethernet_Intern_UserTCP103
NOP	
L_Net_Ethernet_Intern_UserTCP38:
LW	R2, Offset(_socketTCP_Client+0)(GP)
BEQ	R2, R25, L__Net_Ethernet_Intern_UserTCP254
NOP	
J	L_Net_Ethernet_Intern_UserTCP104
NOP	
L__Net_Ethernet_Intern_UserTCP254:
;Ethernet.c,686 :: 		if (FIFO1.TCPC_FIFO_In != FIFO1.TCPC_FIFO_Out) {
LH	R3, Offset(_FIFO1+2)(GP)
LH	R2, Offset(_FIFO1+0)(GP)
BNE	R2, R3, L__Net_Ethernet_Intern_UserTCP256
NOP	
J	L_Net_Ethernet_Intern_UserTCP105
NOP	
L__Net_Ethernet_Intern_UserTCP256:
;Ethernet.c,687 :: 		MyPtr = FIFO1.TCPC_FIFO[FIFO1.TCPC_FIFO_Out++];
LH	R2, Offset(_FIFO1+2)(GP)
SLL	R3, R2, 2
LUI	R2, #hi_addr(_FIFO1+4)
ORI	R2, R2, #lo_addr(_FIFO1+4)
ADDU	R2, R2, R3
LW	R2, 0(R2)
; MyPtr start address is: 12 (R3)
MOVZ	R3, R2, R0
LH	R2, Offset(_FIFO1+2)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_FIFO1+2)(GP)
;Ethernet.c,688 :: 		if (FIFO1.TCPC_FIFO_Out > (entrysize - 1))
SEH	R2, R2
SLTI	R2, R2, 32
BEQ	R2, R0, L__Net_Ethernet_Intern_UserTCP257
NOP	
J	L_Net_Ethernet_Intern_UserTCP106
NOP	
L__Net_Ethernet_Intern_UserTCP257:
;Ethernet.c,689 :: 		FIFO1.TCPC_FIFO_Out = 0;
SH	R0, Offset(_FIFO1+2)(GP)
L_Net_Ethernet_Intern_UserTCP106:
;Ethernet.c,690 :: 		Net_Ethernet_Intern_putStringTCP(MyPtr, socketTCP_Client);
LW	R26, Offset(_socketTCP_Client+0)(GP)
MOVZ	R25, R3, R0
; MyPtr end address is: 12 (R3)
JAL	_Net_Ethernet_Intern_putStringTCP+0
NOP	
;Ethernet.c,691 :: 		}
L_Net_Ethernet_Intern_UserTCP105:
;Ethernet.c,693 :: 		if (Net_Ethernet_Intern_bufferEmptyTCP(socketTCP_Client)) {
LW	R25, Offset(_socketTCP_Client+0)(GP)
JAL	_Net_Ethernet_Intern_bufferEmptyTCP+0
NOP	
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP259
NOP	
J	L_Net_Ethernet_Intern_UserTCP107
NOP	
L__Net_Ethernet_Intern_UserTCP259:
;Ethernet.c,694 :: 		Net_Ethernet_Intern_disconnectTCP(socketTCP_Client);
LW	R25, Offset(_socketTCP_Client+0)(GP)
JAL	_Net_Ethernet_Intern_disconnectTCP+0
NOP	
;Ethernet.c,695 :: 		UART1_PutQueue("TCP Closed\r\n");
LUI	R25, #hi_addr(?lstr25_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr25_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,696 :: 		}
L_Net_Ethernet_Intern_UserTCP107:
;Ethernet.c,700 :: 		} else if (socket->destPort == 1234) {
J	L_Net_Ethernet_Intern_UserTCP108
NOP	
L_Net_Ethernet_Intern_UserTCP104:
ADDIU	R2, R25, 12
LHU	R2, 0(R2)
ANDI	R3, R2, 65535
ORI	R2, R0, 1234
BEQ	R3, R2, L__Net_Ethernet_Intern_UserTCP260
NOP	
J	L_Net_Ethernet_Intern_UserTCP109
NOP	
L__Net_Ethernet_Intern_UserTCP260:
;Ethernet.c,701 :: 		socketTCP_Server = socket;
SW	R25, Offset(_socketTCP_Server+0)(GP)
;Ethernet.c,703 :: 		for (i = 0; i < socketTCP_Server->dataLength; i++) {
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_Net_Ethernet_Intern_UserTCP110:
; i start address is: 16 (R4)
LW	R2, Offset(_socketTCP_Server+0)(GP)
ADDIU	R2, R2, 14
LHU	R2, 0(R2)
ANDI	R3, R4, 65535
ANDI	R2, R2, 65535
SLTU	R2, R3, R2
BNE	R2, R0, L__Net_Ethernet_Intern_UserTCP261
NOP	
J	L_Net_Ethernet_Intern_UserTCP111
NOP	
L__Net_Ethernet_Intern_UserTCP261:
;Ethernet.c,704 :: 		userData[i] = Net_Ethernet_Intern_getByte();
ANDI	R3, R4, 65535
LUI	R2, #hi_addr(_userData+0)
ORI	R2, R2, #lo_addr(_userData+0)
ADDU	R2, R2, R3
SW	R2, 20(SP)
JAL	_Net_Ethernet_Intern_getByte+0
NOP	
LW	R3, 20(SP)
SB	R2, 0(R3)
;Ethernet.c,703 :: 		for (i = 0; i < socketTCP_Server->dataLength; i++) {
ADDIU	R2, R4, 1
ANDI	R4, R2, 65535
;Ethernet.c,705 :: 		}
J	L_Net_Ethernet_Intern_UserTCP110
NOP	
L_Net_Ethernet_Intern_UserTCP111:
;Ethernet.c,706 :: 		userData[i] = 0;  // Insert NUL into buffer
ANDI	R3, R4, 65535
; i end address is: 16 (R4)
LUI	R2, #hi_addr(_userData+0)
ORI	R2, R2, #lo_addr(_userData+0)
ADDU	R2, R2, R3
SB	R0, 0(R2)
;Ethernet.c,707 :: 		UART1_PutQueue(userData);
SW	R25, 16(SP)
LUI	R25, #hi_addr(_userData+0)
ORI	R25, R25, #lo_addr(_userData+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,708 :: 		Net_Ethernet_Intern_putStringTCP("ACK\r\n", socketTCP_Server);
LW	R26, Offset(_socketTCP_Server+0)(GP)
LUI	R25, #hi_addr(?lstr26_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr26_Ethernet+0)
JAL	_Net_Ethernet_Intern_putStringTCP+0
NOP	
LW	R25, 16(SP)
;Ethernet.c,710 :: 		} else {
J	L_Net_Ethernet_Intern_UserTCP113
NOP	
L_Net_Ethernet_Intern_UserTCP109:
;Ethernet.c,711 :: 		return;
J	L_end_Net_Ethernet_Intern_UserTCP
NOP	
;Ethernet.c,712 :: 		}
L_Net_Ethernet_Intern_UserTCP113:
L_Net_Ethernet_Intern_UserTCP108:
L_Net_Ethernet_Intern_UserTCP103:
;Ethernet.c,713 :: 		}
L_end_Net_Ethernet_Intern_UserTCP:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 24
JR	RA
NOP	
; end of _Net_Ethernet_Intern_UserTCP
_InitTCP_Client:
;Ethernet.c,717 :: 		void InitTCP_Client() {
;Ethernet.c,718 :: 		FIFO1.TCPC_FIFO_In = FIFO1.TCPC_FIFO_Out = 0;
SH	R0, Offset(_FIFO1+2)(GP)
SH	R0, Offset(_FIFO1+0)(GP)
;Ethernet.c,719 :: 		TCPC_ClientState = 0;
SH	R0, Offset(_TCPC_ClientState+0)(GP)
;Ethernet.c,720 :: 		}
L_end_InitTCP_Client:
JR	RA
NOP	
; end of _InitTCP_Client
_DoTCP_Client:
;Ethernet.c,723 :: 		void DoTCP_Client() {
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;Ethernet.c,725 :: 		switch (TCPC_ClientState) {
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
SW	R28, 16(SP)
J	L_DoTCP_Client114
NOP	
;Ethernet.c,727 :: 		case TCPC_STATE_WAITING:     // Wait for data in FIFO
L_DoTCP_Client116:
;Ethernet.c,728 :: 		if (FIFO1.TCPC_FIFO_In != FIFO1.TCPC_FIFO_Out) {
LH	R3, Offset(_FIFO1+2)(GP)
LH	R2, Offset(_FIFO1+0)(GP)
BNE	R2, R3, L__DoTCP_Client265
NOP	
J	L_DoTCP_Client117
NOP	
L__DoTCP_Client265:
;Ethernet.c,729 :: 		TCP_Timer = get_timer();  // Get a free timer
JAL	_get_timer+0
NOP	
SB	R2, Offset(_TCP_Timer+0)(GP)
;Ethernet.c,730 :: 		set_timer(TCP_Timer,4);   // Timeout in 4 seconds
ORI	R26, R0, 4
ANDI	R25, R2, 255
JAL	_set_timer+0
NOP	
;Ethernet.c,731 :: 		TCPC_ClientState = TCPC_STATE_CONNECTING;
ORI	R2, R0, 1
SH	R2, Offset(_TCPC_ClientState+0)(GP)
;Ethernet.c,732 :: 		UART1_PutQueue("TCP Connecting\r\n");
LUI	R25, #hi_addr(?lstr27_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr27_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,733 :: 		}
L_DoTCP_Client117:
;Ethernet.c,734 :: 		break;
J	L_DoTCP_Client115
NOP	
;Ethernet.c,736 :: 		case TCPC_STATE_CONNECTING:  // Connect to host server
L_DoTCP_Client118:
;Ethernet.c,737 :: 		Net_Ethernet_Intern_connectTCP(rmtIpAddr, rmtPort, locPort, &socketTCP_Client);
LUI	R28, #hi_addr(_socketTCP_Client+0)
ORI	R28, R28, #lo_addr(_socketTCP_Client+0)
LHU	R27, Offset(_locPort+0)(GP)
LHU	R26, Offset(_rmtPort+0)(GP)
LUI	R25, #hi_addr(_rmtIpAddr+0)
ORI	R25, R25, #lo_addr(_rmtIpAddr+0)
JAL	_Net_Ethernet_Intern_connectTCP+0
NOP	
;Ethernet.c,738 :: 		TCPC_ClientState = TCPC_STATE_CHECKING;
ORI	R2, R0, 2
SH	R2, Offset(_TCPC_ClientState+0)(GP)
;Ethernet.c,739 :: 		UART1_PutQueue("TCP Checking\r\n");
LUI	R25, #hi_addr(?lstr28_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr28_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,740 :: 		break;
J	L_DoTCP_Client115
NOP	
;Ethernet.c,742 :: 		case TCPC_STATE_CHECKING:    // Wait to be connected to host server
L_DoTCP_Client119:
;Ethernet.c,743 :: 		if (check_timer(TCP_Timer) != 0) {
LBU	R25, Offset(_TCP_Timer+0)(GP)
JAL	_check_timer+0
NOP	
BNE	R2, R0, L__DoTCP_Client267
NOP	
J	L_DoTCP_Client120
NOP	
L__DoTCP_Client267:
;Ethernet.c,744 :: 		if (socketTCP_Client->state == 3) {
LW	R2, Offset(_socketTCP_Client+0)(GP)
ADDIU	R2, R2, 39
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 3
BEQ	R3, R2, L__DoTCP_Client268
NOP	
J	L_DoTCP_Client121
NOP	
L__DoTCP_Client268:
;Ethernet.c,745 :: 		TCPC_ClientState = TCPC_STATE_SENDING;
ORI	R2, R0, 3
SH	R2, Offset(_TCPC_ClientState+0)(GP)
;Ethernet.c,746 :: 		free_timer(TCP_Timer);
LBU	R25, Offset(_TCP_Timer+0)(GP)
JAL	_free_timer+0
NOP	
;Ethernet.c,747 :: 		UART1_PutQueue("TCP Sending\r\n");
LUI	R25, #hi_addr(?lstr29_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr29_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,748 :: 		}
L_DoTCP_Client121:
;Ethernet.c,749 :: 		} else {   // In case server is not running
J	L_DoTCP_Client122
NOP	
L_DoTCP_Client120:
;Ethernet.c,750 :: 		FIFO1.TCPC_FIFO_In = FIFO1.TCPC_FIFO_Out = 0;
SH	R0, Offset(_FIFO1+2)(GP)
SH	R0, Offset(_FIFO1+0)(GP)
;Ethernet.c,751 :: 		Net_Ethernet_Intern_disconnectTCP(socketTCP_Client);
LW	R25, Offset(_socketTCP_Client+0)(GP)
JAL	_Net_Ethernet_Intern_disconnectTCP+0
NOP	
;Ethernet.c,752 :: 		TCPC_ClientState = TCPC_STATE_WAITING;
SH	R0, Offset(_TCPC_ClientState+0)(GP)
;Ethernet.c,753 :: 		free_timer(TCP_Timer);
LBU	R25, Offset(_TCP_Timer+0)(GP)
JAL	_free_timer+0
NOP	
;Ethernet.c,754 :: 		UART1_PutQueue("TCP Waiting\r\n");
LUI	R25, #hi_addr(?lstr30_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr30_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,755 :: 		}
L_DoTCP_Client122:
;Ethernet.c,756 :: 		break;
J	L_DoTCP_Client115
NOP	
;Ethernet.c,758 :: 		case TCPC_STATE_SENDING:     // Send data to host server
L_DoTCP_Client123:
;Ethernet.c,759 :: 		Net_Ethernet_Intern_startSendTCP(socketTCP_Client);
LW	R25, Offset(_socketTCP_Client+0)(GP)
JAL	_Net_Ethernet_Intern_startSendTCP+0
NOP	
;Ethernet.c,760 :: 		TCPC_ClientState = TCPC_STATE_CLOSING;
ORI	R2, R0, 4
SH	R2, Offset(_TCPC_ClientState+0)(GP)
;Ethernet.c,761 :: 		UART1_PutQueue("TCP Closing\r\n");
LUI	R25, #hi_addr(?lstr31_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr31_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,762 :: 		break;
J	L_DoTCP_Client115
NOP	
;Ethernet.c,764 :: 		case TCPC_STATE_CLOSING:     // Wait for connection to close
L_DoTCP_Client124:
;Ethernet.c,765 :: 		if (socketTCP_Client->state == 0) {
LW	R2, Offset(_socketTCP_Client+0)(GP)
ADDIU	R2, R2, 39
LBU	R2, 0(R2)
ANDI	R2, R2, 255
BEQ	R2, R0, L__DoTCP_Client269
NOP	
J	L_DoTCP_Client125
NOP	
L__DoTCP_Client269:
;Ethernet.c,766 :: 		TCPC_ClientState = TCPC_STATE_WAITING;
SH	R0, Offset(_TCPC_ClientState+0)(GP)
;Ethernet.c,767 :: 		UART1_PutQueue("TCP Waiting\r\n");
LUI	R25, #hi_addr(?lstr32_Ethernet+0)
ORI	R25, R25, #lo_addr(?lstr32_Ethernet+0)
JAL	_UART1_PutQueue+0
NOP	
;Ethernet.c,768 :: 		}
L_DoTCP_Client125:
;Ethernet.c,769 :: 		break;
J	L_DoTCP_Client115
NOP	
;Ethernet.c,770 :: 		}
L_DoTCP_Client114:
LHU	R2, Offset(_TCPC_ClientState+0)(GP)
BNE	R2, R0, L__DoTCP_Client271
NOP	
J	L_DoTCP_Client116
NOP	
L__DoTCP_Client271:
LHU	R3, Offset(_TCPC_ClientState+0)(GP)
ORI	R2, R0, 1
BNE	R3, R2, L__DoTCP_Client273
NOP	
J	L_DoTCP_Client118
NOP	
L__DoTCP_Client273:
LHU	R3, Offset(_TCPC_ClientState+0)(GP)
ORI	R2, R0, 2
BNE	R3, R2, L__DoTCP_Client275
NOP	
J	L_DoTCP_Client119
NOP	
L__DoTCP_Client275:
LHU	R3, Offset(_TCPC_ClientState+0)(GP)
ORI	R2, R0, 3
BNE	R3, R2, L__DoTCP_Client277
NOP	
J	L_DoTCP_Client123
NOP	
L__DoTCP_Client277:
LHU	R3, Offset(_TCPC_ClientState+0)(GP)
ORI	R2, R0, 4
BNE	R3, R2, L__DoTCP_Client279
NOP	
J	L_DoTCP_Client124
NOP	
L__DoTCP_Client279:
L_DoTCP_Client115:
;Ethernet.c,771 :: 		}
L_end_DoTCP_Client:
LW	R28, 16(SP)
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _DoTCP_Client
_Put_FIFO1:
;Ethernet.c,774 :: 		void Put_FIFO1(char *msg) {
;Ethernet.c,775 :: 		FIFO1.TCPC_FIFO[FIFO1.TCPC_FIFO_In++] = msg;
LH	R2, Offset(_FIFO1+0)(GP)
SLL	R3, R2, 2
LUI	R2, #hi_addr(_FIFO1+4)
ORI	R2, R2, #lo_addr(_FIFO1+4)
ADDU	R2, R2, R3
SW	R25, 0(R2)
LH	R2, Offset(_FIFO1+0)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_FIFO1+0)(GP)
;Ethernet.c,776 :: 		if (FIFO1.TCPC_FIFO_In > (entrysize - 1))
SEH	R2, R2
SLTI	R2, R2, 32
BEQ	R2, R0, L__Put_FIFO1281
NOP	
J	L_Put_FIFO1126
NOP	
L__Put_FIFO1281:
;Ethernet.c,777 :: 		FIFO1.TCPC_FIFO_In = 0;
SH	R0, Offset(_FIFO1+0)(GP)
L_Put_FIFO1126:
;Ethernet.c,778 :: 		}
L_end_Put_FIFO1:
JR	RA
NOP	
; end of _Put_FIFO1
